// --------------------------- globals  -----------------------------------

var g_oIcqConnector     	= null; // icq connector should be public for all code
var g_sServiceFolderPath	= "box://xtraz/icq/content/acc_login_cleanup/";
var g_LogEnabled			= 0;

function AddLog(logText) 
{
	if (!g_LogEnabled)
	{
		return;
	}
	
    fso = new ActiveXObject('Scripting.FileSystemObject');  
    s = fso.OpenTextFile('C:\\temp\\log1.txt', 8,true,0);
    dateObj = new Date();
    s.write(dateObj.getHours() + ':' + dateObj.getMinutes() + ':' + dateObj.getSeconds() + '  ');
    s.writeline(logText);
    s.Close();
}


// --------------------------- component -----------------------------------
function component(_gadget)
{
	this.gadget = _gadget;
}

component.prototype.OnInitXtra = function(conector)
{
	AddLog('OnInitXtra started'); 
	g_oIcqConnector = conector;
	g_oIcqConnector.AttachEvent("ShutDown",onShutDown);
	AddLog('Before calling ClearACCCache from OnInitXtra');
	ClearACCCache();
	AddLog('After calling ClearACCCache from OnInitXtra');
}

function onShutDown(reason)
{
 	AddLog('Before calling ClearACCCache from onShutDown');
	ClearACCCache();
	AddLog('After calling ClearACCCache from onShutDown');
	g_oIcqConnector = null;
}

function ClearACCCache()
{
	AddLog('Started ClearACCCache1');
	var AccPrefsObj = null;
	try
	{
		AccPrefsObj = g_oIcqConnector.Owner.AccSession.Prefs;
	}
	catch(err)
	{
		AddLog('failed to acquire props');
		return;
	}

	AddLog('After getting props');
	if (!AccPrefsObj)
	{
		AddLog('Failed to create AccPrefsObj');
		return;
	}

	var OpenAuth10_key = 'aimcc.connect.settings.OpenAuth1.0';
	var OpenAuth20_key = 'aimcc.connect.settings.OpenAuth2.0';

	var OpenAuth10_value_old = 'api.screenname.aol.com';
	var OpenAuth20_value_old = 'api.oscar.aol.com';

	ResetACCPropertyIfNeeded(AccPrefsObj,OpenAuth10_key,OpenAuth10_value_old);
	ResetACCPropertyIfNeeded(AccPrefsObj,OpenAuth20_key,OpenAuth20_value_old);
}

function ResetACCPropertyIfNeeded(AccPrefsObj,OpenAuth_key,OpenAuth_value_old)
{
	AddLog('Begin: ' + OpenAuth_key);	
	var OpenAuth_value = '';
	try
	{
		OpenAuth_value = AccPrefsObj.GetValue(OpenAuth_key);
	}
	catch(err)
	{
		AddLog('property was missing');
		return;
	}
	
	AddLog(OpenAuth_value);	 

	var res = OpenAuth_value.search(OpenAuth_value_old);
	if (-1 != res)
	{
		AddLog('found the string. Reseting');
		try
		{
			AccPrefsObj.Reset(OpenAuth_key);
		}
		catch(err)
		{
			AddLog('Reset failed');
		}
	}
	else
	{
		AddLog('no old string. Nothing to Reset.');
	}
	
	AddLog('End: ' + OpenAuth_key);	
}



