/* ---------------------------------------------------------
icqAPI infrastructure IMPLEMINTATION
------------------------------------------------------------
This file is responsible for general complex ICQ actions, based on the ICQ connector
--------------------------------------------------------- */

//Enums
MEClientColor =
{
    kColor_TitleText: 1,
    kColor_ButtonHover: 2
};

function icqConnectorEx(connector) {
    this._connector = connector;
}

icqConnectorEx.prototype.openSearch = function() {
    this._connector.App.CommandManager.CreateCommand("FindUsers").Execute();
}

icqConnectorEx.prototype.openAddUser = function(screenName, displayName) {
    var command = this._connector.App.CommandManager.CreateCommand("AddUser");
    command.Owner = this._connector.Owner;
    var userToAdd = this._connector.Owner.GetUser(screenName, true);
    if (displayName)
        userToAdd.DisplayName = displayName;

    command.UserToAdd = userToAdd;
    command.OpenModal = true;
    command.Protocol = "wim";
    command.CheckGroups = false;
    command.Execute();

    return true;
}

icqConnectorEx.prototype.openUserProfile = function(screenName, displayName) {
    var command = this._connector.App.CommandManager.CreateCommand("ShowUserDetails");
    command.Owner = this._connector.Owner;
    command.User = this._connector.Owner.GetUser(screenName, true);
    if (displayName)
        command.User.DisplayName = displayName;
        
    command.Execute();
}

icqConnectorEx.prototype.getClientColor = function(colorType, defaultColor) {
    var brushName;
    switch (colorType) {
        case MEClientColor.kColor_TitleText:
            brushName = 'Brush.sGlbCommonText';
            break;
        case MEClientColor.kColor_ButtonHover:
            brushName = 'Brush.sGlbGlobalOver_1';
            break;
        default: // Unsupported type
            brushName = '';
    }

    if (brushName == '')
        return defaultColor; // Return back the default if not supported

    // Make sure the resource is defined correctly, and convert from boxely color to HTML color
    var brush = icqConnector.GetObject('ResourceInfoManager').findResourceByURL(brushName);
    return (brush.tag == 'solidBrush') ? '#' + (brush.fill.toString(16)).substr(2) : defaultColor;
}

icqConnectorEx.prototype.loadStringEx = function(sPath, sResId) {
    
}