// Array.pop() - Remove and return the last element of an array
if ( typeof Array.prototype.pop=="undefined" ) {
	Array.prototype.pop = function() {
		var b = this[this.length-1];
		this.length--;
		return b;
	};
}

// Array.push() - Add an element to the end of an array, return the new length
if ( typeof Array.prototype.push=="undefined" ) {
	Array.prototype.push = function() {
		var arr = arguments;
		for( var i = 0, elem = this.length, len = arr.length; i<len; i++ ) {
			this[elem+i] = arr[i];
		}
		return this.length;
	};
}

if ( typeof Array.prototype.concat=="undefined" ) {
	Array.prototype.concat = function(arr) {
		var ret = this.copy();
		for( var i = 0; i<arr.length; i++ ) {
			ret[ret.length] = arr[i];
		}
		return ret;
	};
}

if ( typeof Array.prototype.copy=="undefined" ) {
	Array.prototype.copy = function() {
		var arr = [], i = this.length;
		while( i-- ) {
			arr[i] = typeof this[i].copy!=="undefined" ? this[i].copy() : this[i];
		}
		return arr;
	};
}

// Array.slice() - return a consecutive subarray
if ( typeof Array.prototype.slice=="undefined" ) {
	Array.prototype.slice = function( a, num ) {
		var i, b, d = [], len = this.length;
		if ( !num ) { num = len; }
		if ( num<0 ) { num = len + num; }
		if ( a<0 ) { 
			a = len - a; 
		}
		if ( num<a ) { i = a; a = num; num = i; }
		for( i = 0; i < num - a; i++ ) { 
			d[i] = this[a+i]; 
		}
		return d;
	};
}

// Array.shift() - pop and return the first element
if ( typeof Array.prototype.shift=="undefined" ) {
	Array.prototype.shift = function() {
		for( var i = 0, b = this[0], len = this.length-1; i<len; i++ ) {
			this[i] = this[i+1];
		}
		this.length--;
		return b;
	};
}

// Array.splice() - Remove or replace several elements and return any deleted elements
if ( typeof Array.prototype.splice=="undefined" ) {
	Array.prototype.splice = function( a, num ) {
		var i = 0;
		var e = arguments;
		var d = this.copy(); 
		var f = a, len = this.length;
		if ( !num ) { 
			num = len - a; 
		}
		for( i; i < e.length - 2; i++ ) { 
			this[a + i] = e[i + 2]; 
		}
		for( a; a < len - num; a++ ) { 
			this[a + e.length - 2] = d[a - num]; 
		}
		this.length -= num - e.length + 2;
		return d.slice( f, f + num );
	};
}
// Array.unshift() - Add an element to the beginning of an array
if ( typeof Array.prototype.unshift=="undefined" ) {
	Array.prototype.unshift = function() {
		this.reverse();
		var arr = arguments, i = arr.length;
		while(i--) { 
			this.push(arr[i]); 
		}
		this.reverse();
		return this.length;
	};
}