/**
 * @author		Mor.y
 * @date        7/7/2005
 * @change
 * @desc 		This include makes a global variable named icqConnector.
 * 				With The icqConnector you can use the ICQ API.
 * @example 	icqConnector.ClosePluginUISite()
 */

if(	typeof(XtrazDebug) == "undefined" )
{	
	XtrazDebug = new Object
	XtrazDebug.alert = XtrazDebug.trace =  XtrazDebug.flush =
		XtrazDebug.assert = XtrazDebug.start = 
		XtrazDebug.catchWindowErrors = XtrazDebug.setUnique = Function();
}
	 
if (top.XtrazConnector) {
	XtrazConnector = top.XtrazConnector;
}
else {	 

//====== Begin conditional class definition ============
	var XtrazConnector = {
		gTransID : 1,
		gSequence : 0,
		Owner : {},
		buddies : new Array,
		SessionID : -1,
		PluginID : '',
		icqConnector: null,
		paramsObject : null,

// Events to broadcast
		msgShutdown : 'shut!',
		msgBuddyDisconnected : 'bDis', // sBuddy
		msgBuddyQuit : 'bQuit', // sBuddy
		msgBuddyStatus : 'bStatus' // sBuddy, nStatus
	}

	/// global functions

	XtrazConnector.getIcqConnector = function () {
		if (! XtrazConnector.icqConnector){
			var objects = document.getElementsByTagName("OBJECT")
			for(var i=0;i<objects.length;i++){
				if(objects[i].classid == "clsid:8D18DFF4-0943-4347-8BCA-0C57033F6820" ) {
					XtrazConnector.icqConnector = objects[i];
					break;
				}
			}
		}

		return	XtrazConnector.icqConnector;
	}

	XtrazConnector.getICQConnector = XtrazConnector.getIcqConnector;
	XtrazConnector.getConnector = XtrazConnector.getIcqConnector;

	XtrazConnector.icqConnectorInit = function () {
		try {
			window.detachEvent("onload", XtrazConnector.icqConnectorInit);
		}
		catch (e){}
		var connector = XtrazConnector.getIcqConnector();
		top.icqConnector = connector;
		var parms = XtrazConnector.getParams();
		var id =  parms.id;
		//XtrazDebug.assert(isDefined(id), "no id in url params");
		var mode = parms.mode;
		
		if( id ){
			try {
				XtrazDebug.trace("initializing connector " , String(connector) , " with id " , id);
				connector.Initialize(id);
				XtrazDebug.trace("done calling initialize");
			} catch(e) {
				  XtrazDebug.trace("icqConnectorInit", e);
			}
		}
		else {
			XtrazDebug.trace("icqConnectorInit: missing ID");
		}
	}

	
	XtrazConnector.getParams = function() 
	{
		if (XtrazConnector.paramsObject)
				return XtrazConnector.paramsObject;
			var tmp = document.location.search;
			var obj = new Object();
		
			if (tmp.length > 1) 
			{
				tmp = tmp.substring(1, tmp.length);
				var pairs = tmp.split("&");
				for( var i = 0; i < pairs.length; i++ )
				{
					var pair = pairs[i];
					var ind = pair.indexOf('=');
					if (ind > 0) 
					{
						var key = pair.substring(0, ind);
						var val = pair.substring(ind + 1, pair.length);
						obj[key] = val;
					}
				}
			}
			else
				XtrazDebug.alert('getparams: no search string');
			XtrazConnector.paramsObject = obj;
			return obj;
	}

	XtrazConnector.onInitData = function(owner, sequence, buddies ,initialData) {
		var connector = XtrazConnector.getIcqConnector();
		XtrazConnector.gSequence = sequence;
		XtrazConnector.Owner.DisplayName = connector.GetIMOwnerData("DISPLAY_NAME");
		XtrazConnector.Owner.ScreenName = owner.ScreenName;
	}
	
	XtrazConnector.removeBuddy = function(sBuddy) {
		for (var i = 0; i < XtrazConnector.buddies.length; i++) {
			if (XtrazConnector.buddies[i] == sBuddy) {
				try {
					XtrazConnector.buddies.splice(i, 1);
				}
				catch (e) {}
				break;
			}
		}
	}
	
	XtrazConnector.addBuddy = function(sBuddy) {
		for (var i = 0; i < XtrazConnector.buddies.length; i++) {
			if (XtrazConnector.buddies[i] == sBuddy)
				return;
		}
		XtrazConnector.buddies[XtrazConnector.buddies.length] = sBuddy;
	}
	
	XtrazConnector.getBuddyName = function() {
		var ret;
		if (XtrazConnector.buddies)
			return XtrazConnector.buddies[0];
		else
			ret = '';
		return ret;
	}

	window.attachEvent("onload", XtrazConnector.icqConnectorInit) 
}
