/******************************************
// XtrazPrefTree
// ** Interface **
// getPreference (key [, more key...] )
// setPreference (key [, more keys...], value)
// getSubPreferences
// clone
// countCategories
//
// ** Dependencies **
// XtrazDebug
*******************************************/

function XtrazPrefTree() {
	this.m_oPreferences = new Object;
	this.m_subPrefs = new Object;
	this.m_nCategories = 0;
	this.m_nProperties = 0;
}

var undefined;
XtrazPrefTree.prototype = new Object;

/*XtrazPrefTree.prototype.getName = function () {
	return m_sName;
}

	XtrazPrefTree.prototype.beginUpdate = function () {
//		trace("prefs " + getName() + " begin update");
	m_nUpdateLevel++;
	for (var key in m_subPrefs) {
		m_subPrefs[key].beginUpdate();
	}
}

XtrazPrefTree.prototype.endUpdate = function (bResetDirty : Boolean) {
	if (m_nUpdateLevel > 0)
		m_nUpdateLevel--;
	if (bResetDirty)
		clearDirty();
	if ((! bResetDirty) and (m_nUpdateLevel == 0)) {
//			trace("prefs " + getName() + " end update, dirty is " + Dirty);
		if (Dirty) {
			onPreferencesChanged(this);
		}
	}
	for (var key in m_subPrefs) {
		m_subPrefs[key].endUpdate(bResetDirty);
	}
}*/

/*	XtrazPrefTree.prototype.onPreferencesChanged = function (oPrefs optional) {
	if (m_oOwner) {
		m_oOwner.onPreferencesChanged(this);
	}
	clearDirty();
} */

XtrazPrefTree.prototype.copy = function (oPrefs/* MCPreferences */) {
	var _p; //: MCPreferences;
	for (var key in this.oPrefs.m_subPrefs) {
		_p = this.addCategory(key);	
		_p.copy(oPrefs.m_subPrefs[key]);
	}
	for (var key in this.oPrefs.m_oPreferences) {
		this.m_oPreferences[key] = oPrefs.m_oPreferences[key];
	}
}

XtrazPrefTree.prototype.clone = function (inPath/*, oOwner */) {
	var prefs/* : MCPreferences */ = this;
	var ret;
	if (inPath) {
		prefs = this.getSubPreferences(inPath);
	}
	if (prefs) {
		ret = prefs._doClone(oOwner);
	}
	return ret;
}

// returns MCPreferences
XtrazPrefTree.prototype.getSubPreferences = function (inPath) {
	var arr = inPath.split('.');
	for (var i = 1; i < arguments.length; i++) {
		arr.push(arguments[i]);
	}
	var ret;
	if (arr.length > 0)
		ret = this._doGetPreference(arr, false);
	return ret;	
}

/**********************************************
getPreference
inKey: String
... : more key strings
**********************************************/
XtrazPrefTree.prototype.getPreference = function (inKey) /* unspecified return value, to avoid compile errors */ {
	var arr = inKey.split('.');
	for (var i = 1; i < arguments.length; i++) {
		arr.push(arguments[i]);
	}
	var ret = '';
	if (arr.length > 0)
		ret = this._doGetPreference(arr, true);
	return ret;
}


/**********************************************
setPreference
inKey: String
... : more key strings
Last argument: value
returns: Boolean
**********************************************/
XtrazPrefTree.prototype.setPreference = function (inKey) {
	var value = arguments[arguments.length - 1];
	var arr = inKey.split('.');
	var argLen = arguments.length;
	if (argLen > 2) {
		argLen--;	
		for (var i = 1; i < argLen; i++) {
			arr.push(arguments[i]);
		}
	}
	return this._doSetPreference(arr, value);
}

// returns XtrazPrefTree Object
XtrazPrefTree.prototype.addCategory = function (sKey) {
//	XtrazDebug.trace("adding category", sKey);
	var arr = sKey.split('.');
	var argLen = arguments.length;
	if (argLen > 1) {
		for (var i = 1; i < argLen; i++) {
			arr.push(arguments[i]);
		}
	}

	var ncat = arr.length;
	var _p = this;
	for (var i = 0; i < ncat; i++) {
		_p = _p._addCategory(arr[i]);
	}
	
	return this.m_subPrefs[arr[0]];
}

// returns XtrazPrefTree Object
XtrazPrefTree.prototype._addCategory = function (sKey) {
	var _p /*: MCPreferences */= this.m_subPrefs[sKey];
	if (! _p) {
		_p = new XtrazPrefTree(sKey/*this*/);
		this.m_subPrefs[sKey] = _p;
		this.m_nCategories++;
//			_p.m_nUpdateLevel = m_nUpdateLevel;
	}
	return _p;
}


/*	XtrazPrefTree.prototype.set Dirty = function (bDirty:Boolean) {
	m_bDirty = bDirty;

	if (m_nUpdateLevel == 0) {
		if (m_bDirty) {
			onPreferencesChanged(this);
		}
	}
}

XtrazPrefTree.prototype.get Dirty = function () {
	var ret = m_bDirty;
	if (! ret) {
		for (var key in m_subPrefs) {
			ret = m_subPrefs[key].Dirty;
			if (ret)
				break;
		}
	}
	return ret;
} */

XtrazPrefTree.prototype.countCategories = function () {
	return this.m_nCategories;
}

// returns an Array
XtrazPrefTree.prototype.getCategories = function () {
	var ret = new Array(this.m_nCategories);
	var i = this.m_nCategories - 1;
	for (var key in this.m_subPrefs) {
		ret[i--] = key;
	}
	return ret;
}
// returns an Array
XtrazPrefTree.prototype.getProperties = function () {
	var ret = new Array(this.m_nProperties);
	var i = this.m_nProperties - 1;
	for (var key in this.m_oPreferences) {
		ret[i--] = key;
	}
	return ret;
}

/*	XtrazPrefTree.prototype.getDirtyCategories = function () {
	var ret = new Array(m_nCategories);
	var i = 0;
	var nDirty = 0;
	for (var key in m_subPrefs) {
		if (m_subPrefs[key].Dirty) {
			ret[i++] = key;
			nDirty++;
		}
	}
	ret.splice(nDirty, ret.length - nDirty); // remove empty categories
	return ret;
} */

XtrazPrefTree.prototype.dump = function (bDeep /*:Boolean */) {
	var o = new Object;
	return _dump(o, this.getName(), bDeep);
}

// returns Boolean
XtrazPrefTree.prototype.loadFromXMLString = function (inXML /*, bBroadcast: Boolean */)  {
	var _xml = XMLUtils.loadString(inXML);
	return this.loadFromXML(_xml/*, bBroadcast */);
}

XtrazPrefTree.prototype.loadFromXMLURL = function (inURL /*, bBroadcast:Boolean */) {
	XtrazDebug.trace("prefs loading from " , inURL);
	var _xml = XMLUtils.loadDocument(inURL);
	XtrazDebug.assert(_xml, "loadFromXMLURL: null document");
	this.loadFromXML(_xml);
}

// returns Boolean
XtrazPrefTree.prototype.loadFromXML = function (_xml /*: XML , bBroadcast:Boolean */)  {
	var status = XMLUtils.getParseError(_xml);
	XtrazDebug.assert(status == 0,">>bad xml passed to preferences, status is  ", status , _xml.xml, _xml.parseError.reason);
	var ret = false;
	if (status == 0) {
	//		beginUpdate();
		this._loadFromXML(_xml.documentElement);
		XtrazDebug.trace("loaded prefs");
	//		endUpdate(! bBroadcast); // if we don't want to broadcast, endupdate will reset the dirty bit
	//		if (bBroadcast)
	//			m_oOwner.onPreferencesLoaded(this);
		ret = true;
	}
	return ret;
}

/*	XtrazPrefTree.prototype.saveToXML = function (bDirtyOnly) : XML {
	var ret : XML = new XML;
	_saveToXML(ret, ret, bDirtyOnly);
	return ret;
}
*/	

// ******* Implementation **********//

// private
XtrazPrefTree.prototype.reset = function () {
	this.m_oPreferences = new Object;
	this.m_subPrefs = new Object;
//		Dirty = false;
}

// private
/*XtrazPrefTree.prototype.clearDirty = function () {
	m_bDirty = false;
	for (var key in m_subPrefs) {
		m_subPrefs[key].clearDirty();
	}
} */

// private
// returns Object
XtrazPrefTree.prototype._doGetPreference = function (aPath, bValue)  {
	var o = this;
	var ret;
	var len = aPath.length;
	if (bValue)
		len--; // length minus last key
	for (var i = 0; i < len; i++) { // dig down to last level
		o = 	o.m_subPrefs[aPath[i]];
		if (undefined == o)
			return null;
	}
	if (bValue)
		ret = o.m_oPreferences[aPath[len]];
	else
		ret = o;

	return ret;
}

// private
// returns Boolean
XtrazPrefTree.prototype._doSetPreference = function (keyArray, inValue) {
	if ( (! (keyArray instanceof Array)) || (keyArray.length <= 0) ) {
		XtrazDebug.trace(0,'>>bad key parameter ' , keyArray , ' for setPreference')
		return false;
	}

	var key = keyArray.shift();

	if (keyArray.length > 0) { // after shift
		var o = this.m_subPrefs[key];
		if (o) {
			return o._doSetPreference(keyArray, inValue);
		}
		else {
			var _p = this.addCategory(key);
			return _p._doSetPreference(keyArray, inValue);
		}
	}
	else { // single key, this is a leaf
		this.m_nProperties++;
		this.m_oPreferences[key] = this.parseValue(inValue);
//			Dirty = true;
	}
	return true;
}

// private
XtrazPrefTree.prototype._doClone = function (/*oOwner */) {
	var ret = new XtrazPrefTree(/*this.getName() , oOwner */);
	for (var key in this.m_oPreferences) {
		ret.m_oPreferences[key] = this.m_oPreferences[key];
	}
	for (var subPref in this.m_subPrefs) {
		ret.m_subPrefs[subPref] = this.m_subPrefs[subPref]._doClone(this);
		ret.m_nCategories++;
	}
	return ret;
}

// private
XtrazPrefTree.prototype._dump = function (oMap, sPrefix, bDeep) {
	var dotPrefix;

	if (sPrefix.length > 0)
		sPrefix += '.';

	for (var key in this.m_oPreferences) {
		oMap[sPrefix + key] = this.m_oPreferences[key];
	}
	if (bDeep) {
		for (var subPref in this.m_subPrefs) {
			this.m_subPrefs[subPref]._dump(oMap, sPrefix + subPref, bDeep);
		}
	}
	return oMap;
}

// private
XtrazPrefTree.prototype._loadFromXML = function (_xml /* XML */) {
	var len = _xml.childNodes.length;
	for (var i = 0; i < len; i++) {
		var node = _xml.childNodes[i];
		var child = node.firstChild;
		if (node.nodeType == xmlNODE_TEXT) {
			if (! XMLUtils.isBlankNode(node))
				this.setPreference(node.nodeName, child.nodeValue);
			else
				XtrazDebug.trace("blank node");
		}
		else if (! child)
			continue;
		
		else if ((child.nodeType == xmlNODE_TEXT) && (! XMLUtils.isBlankNode(child))) {
			this.setPreference(node.nodeName, child.nodeValue);
		}
		else {
			if (! this.m_subPrefs[node.nodeName])
				this.addCategory(node.nodeName);
			var pref = this.m_subPrefs[node.nodeName];
			pref._loadFromXML(node);
		}
	}
}

// _xml is the node into which we're saving. _topXML is the top node	
// private
XtrazPrefTree.prototype._saveToXML = function (_xml /*:XML */, _topXML /*:XML *//*, bDirtyOnly : Boolean */) {
//		var bNotDirty = ! bDirtyOnly;
	if (this.m_nProperties > 0) {
		for (var key in this.m_oPreferences) {
			var node = _topXML.createElement(key);
			var value = _topXML.createTextNode(m_oPreferences[key]);
			node.appendChild(value);
			_xml.appendChild(node);
		}
	}
	else if (m_nCategories > 0) {
		var subPref;
		for (var key in m_subPrefs) {
			subPref = m_subPrefs[key];
//				trace("���_savetoxml, category " + key + ", bDirtyOnly is " + bDirtyOnly + ", bNotDirty is " + bNotDirty + " subpref dirty is " + subPref.Dirty);
//				if (bNotDirty or subPref.Dirty) {
				var node = _topXML.createElement(key);
				subPref._saveToXML(node, _topXML);
				_xml.appendChild(node);
//				}
		}
	}
	return _xml;
}

// private
XtrazPrefTree.prototype.parseValue = function (sValue) {
	if (typeof(sValue) == "string") {
		var ret = sValue;
		var s = sValue.toLowerCase();
		if (s == "false")
			ret = false;
		else if (s == "true")
			ret = true;
		return ret;
	}
	else
		return sValue;	
}

