
var undefined;

var XtrazUtils = new Object;

/********* Browser detection *************/
XtrazUtils.browser = new Object;

var appName = navigator.appVersion.toLowerCase();
var agent = navigator.userAgent.toLowerCase(); 

XtrazUtils.browser.isIE = (appName.indexOf("msie") >= 0);
XtrazUtils.browser.isGecko = (appName.indexOf("gecko") >= 0);
XtrazUtils.browser.isDOM = (typeof(document.getElementById) == "function");
XtrazUtils.browser.isWindows = (agent.indexOf("windows") >= 0);
XtrazUtils.browser.is98 = (agent.indexOf("98") > 0);

/********* End Browser detection *************/
XtrazUtils.gXMLCountriesDoc = null;
XtrazUtils.gCountriesPool = null;
XtrazUtils.gTextPool = null;
XtrazUtils.gLangMap =null;
XtrazUtils.gDir = "ltr" // the langueg direction

XtrazUtils.isLocalXtra = function() {
	return (window.location.hostname =="");
}

XtrazUtils.getIeVersion = function() {
	var version = window.navigator.appVersion
	var start = version.indexOf("MSIE ") + 5;
	return parseFloat( version.substr(start,3));
}

XtrazUtils.getLanguageDoc = function(bLocal, connector, xtraID, sLanguage)
{
//	XtrazDebug.trace("load language with",typeof(connector))
	var url = null
	bLocal = bLocal || XtrazUtils.isLocalXtra();
	if (bLocal) {
		url = "text.xml";
	}
	else {
		url = XtrazUtils.getLanguageXMLPath(connector,xtraID, sLanguage);
	}
	XtrazDebug.trace("loading language file from", url);

	var xmlDoc = XMLUtils.loadDocument(url);
	var success;
	var status = XMLUtils.getParseError(xmlDoc);
	if (xmlDoc)
		success = (status == 0);
	else
		success = false;
//success = true;
// if failed, default to English
	if (! success && ! bLocal) { 
		var url1 = XtrazUtils.getLanguageXMLPath(connector,xtraID, "eng");
		if (url1 != url) {
			xmlDoc.load(url1);	
		}
	}

	return xmlDoc;
}

XtrazUtils.loadLanguage = function(bLocal, connector, xtraID, sLanguage) {
	if(connector.GetIMClientData("CLIENT_VERSION")==600){
		XtrazUtils.gLangMap = new XtrazUtils.KeyValueMap();
		XtrazUtils.gLangMap.adopt(g_lang6);
	}
	else{
		XtrazUtils.gLangMap = new XtrazUtils.KeyValueMap();
		XtrazUtils.gLangMap.adopt(g_lang);
	}
	var success = false;
	var xmlDoc = this.getLanguageDoc(bLocal, connector, xtraID, sLanguage);

	if (xmlDoc) {
		if (XMLUtils.getParseError(xmlDoc) != 0) {
			XtrazDebug.trace("language file parse error");
			success = false;
		}
		else {
			success = this.loadLanguageFromXML(xmlDoc);
		}
	}
	if (! success) {
		XtrazDebug.trace("loadLanguage: Language is not supported!");
	}

	return success;
}

XtrazUtils.loadLanguageFromXML = function(xmlDoc) {
	var success = false;
	var productNode = xmlDoc.selectSingleNode("//product");
	if (productNode) {
		var dir = productNode.getAttribute("dir");
		if (XtrazUtils.isNonEmpty(dir))
			XtrazUtils.gDir = dir;
		XtrazUtils.gTextPool = XMLUtils.xmlToHash(productNode);
		success = true;
	}
	return success;
}

XtrazUtils.getLanguageXMLPath = function(connector, xtraID, sLanguage)
{
	var ret;
	if (connector && ! sLanguage) {
		var lngID = connector.GetIMClientData("LANG_ID") ;
		sLanguage = XtrazUtils.codeToLanguage(lngID);
	}
	if (sLanguage)
		ret = "/xtraz2/txt/"+ xtraID +"/"+ sLanguage +"/text.xml";
	
	return ret;
}

XtrazUtils.codeToLanguage = function(nCode) {
nCode=nCode.toString().toLowerCase();
	if (! XtrazUtils.gLangMap) {
		XtrazUtils.gLangMap = new XtrazUtils.KeyValueMap();
		XtrazUtils.gLangMap.adopt(g_lang);
	}
	return XtrazUtils.gLangMap.findKey(nCode);
}

XtrazUtils.loadCountries = function(bLocal,connector)
{
	var success = false;
	var xmlDoc = XMLUtils.makeDocument();
	if (! xmlDoc) {
		return false;
	}
	var url = null
	if( bLocal || XtrazUtils.isLocalXtra() ) {
		bLocal = true;
		url = "countries.xml";
	}
	else {
		url = XtrazUtils.getCountriesXMLPath(connector);
	}
	XtrazDebug.trace("loading countries file from", url);

	success = xmlDoc.load(url);
	if (! success) { // default to English
		var url1 = XtrazUtils.getCountriesXMLPath(connector,"eng");
		if (url1 != url)
			success = xmlDoc.load(url1);	
	}
	if (success) 
	{
		if (XMLUtils.getParseError(xmlDoc) != 0) {
			XtrazDebug.trace("language file parse error");
			success = false;
		}
		else 
		{
			XtrazUtils.gXMLCountriesDoc = xmlDoc;
			var countryNode = xmlDoc.selectSingleNode("//COUNTRIES");
			if (countryNode) {
				XtrazUtils.gCountriesPool = XMLUtils.xmlToHash2(countryNode);
				success = true;
			}
			else {
				success = false;
			}
		}
	}
	if (! success) {XtrazDebug.trace("loadLanguage: Language is not supported!");}

	return success;
}

XtrazUtils.getCountriesXMLPath = function(connector,sLanguage)
{
	if (! XtrazUtils.gLangMap) {
		XtrazUtils.gLangMap = new XtrazUtils.KeyValueMap();
		XtrazUtils.gLangMap.adopt(g_lang);
	}
	if (connector && !sLanguage) {
		var lngID = connector.GetIMClientData("LANG_ID") ;
		sLanguage = XtrazUtils.gLangMap.findKey(lngID);
	}
	return "/xtraz2/txt/countries/"+ sLanguage +"/countries.xml"

}

XtrazUtils.getIntlStrings = function(/*... */) {
	var ret = new Array;
	var len = arguments.length;
	var str;
	for (var i =0; i < len; i++) {
		str = XtrazUtils.getIntlString(arguments[i], '');
		ret.push(str);
	}
	return ret;
}

XtrazUtils.getIntlString = function(strID, sDefault) {
	var txt = ""
	if (XtrazUtils.isEmpty(sDefault))
		sDefault = '';
	else
		sDefault = String(sDefault);
	try{
		txt = XtrazUtils.gTextPool[strID];
		if(XtrazUtils.isEmpty(txt)) {
			txt = sDefault;
		}
	}
	catch(e) 	{
		if(XtrazUtils.isEmpty(txt)) {
			txt = sDefault;
		}
	}
	return txt;
}

XtrazUtils.getIntlStringWithParams = function(tmpl /*, param1, param2... */) {
	var str = XtrazUtils.getIntlString(tmpl);
	var ret = '';
	if (str.length) {
		var arr = new Array; /* arguments.shift seems not to work on some systems */
		for (var i = 1; i < arguments.length; i++) {
			arr.push(arguments[i]);
		}
		ret = XtrazUtils.sprintf(str, arr);
	}
	return ret;
}

XtrazUtils.makeLocalURL = function(sURL, bProtocol) {
	var url = '';
	if (bProtocol == undefined)
		bProtocol = true;

	if (bProtocol) {
		url += window.location.protocol + '//';
	}
	url += window.location.hostname;
	var path = window.location.pathname;
	if (window.location.hostname == '')
		path = path.replace(/\\/g, "/");
		
	var ind = path.lastIndexOf("/");
	url += path.substring(0, path.lastIndexOf("/") + 1);
	url += sURL;
	return url;
}

XtrazUtils.isValidICQNumber = function(num, bAllowEmpty) {
	bAllowEmpty = ! (! bAllowEmpty); // default is false
	var ret = false;
	if (XtrazUtils.isEmpty(num))
		ret = bAllowEmpty;
	else {
		var icqnum;
		var t = typeof(num);
		switch (t) {
			case 'string':
				var illegal = num.match(/[^0-9\-]/);
				if (! illegal) {
					num = num.replace(/[^0-9]/g, '');
					icqnum = Number(num);
				}
				else
					icqnum = 0;
				break;
			case 'number':
				icqnum = num;
				break;
			default:
				icqnum = -1;
		}
		ret = (icqnum > 9999 && icqnum < 1000000000);
	}
	return ret;		
}


/****** Parameter accessing functions **********/
XtrazUtils.paramsObject = null;

XtrazUtils.getParams = function(str) {
	var bUseDefault = (! str);
	if (bUseDefault) {
		if (this.paramsObject)
			return XtrazUtils.paramsObject;
		str = window.location.search;
	}
	var obj = new Object();

	if (str.length > 1) {
		if (str.charAt(0) == '?')
			str = str.substring(1);
//		str = str.substring(1, str.length);
		var pairs = str.split("&");
		for( var i = 0; i < pairs.length; i++ ) {
			var pair = pairs[i];
			var ind = pair.indexOf('=');
			if (ind > 0) {
				var key = pair.substring(0, ind);
				var val = pair.substring(ind + 1, pair.length);
				obj[key] = val;
//				myAlert("found parameter " + key + " value " + val);
			}
		}
	}
	else {
		XtrazDebug.trace('getparams: no search string');
	}
	if (bUseDefault)
		XtrazUtils.paramsObject = obj;
	return obj;
}

// add a parameter to a url string
XtrazUtils.addParamToURL = function (url, key, value) {
	var sep;
	if (url.indexOf("?") > 0)
		sep = '&';
	else
		sep = '?';
	url += (sep + key + '=' + value);
	return url;
}

XtrazUtils.indexOfKey = function(arr, key, value) {
	for (var i = arr.length - 1; i >=0; i--) {
		if (arr[i][key] == value) {
			return i;
		}
	}
	return -1;
}

XtrazUtils.sprintf = function(tmpl) {
	var ret = '';
	var ind = 0;
	var nextInd = 0;
	var args;
	var nextArg;
	if ((arguments.length == 2) && (arguments[1] instanceof Array)) {
		nextArg = 0;
		args = arguments[1];
	}
	else {
		nextArg = 1;
		args = arguments;
	}
	for (var nArgs = args.length;
		nextArg < nArgs; nextArg++) {
		nextInd = tmpl.indexOf("%s", ind);
		if (nextInd >= 0) {
			ret += tmpl.substring(ind, nextInd);
			ret += args[nextArg];
			ind = nextInd + 2;
		}
		else { // no more substitute sites
			break;
		}
	}
	if (ind <= (tmpl.length - 1)) {
		ret += tmpl.substring(ind);
	}
	return ret;
}

XtrazUtils.applyStyleToObject = function(obj, styleName, bAdd) {
	if (arguments.length < 3) {
		bAdd = true;
	}
	if (bAdd)
		XtrazUtils.addStyleToObject(obj, styleName);
	else
		XtrazUtils.removeStyleFromObject(obj, styleName);
}

XtrazUtils.addStyleToObject = function(sobj, styleName) {
	var obj = DOMUtils.getObject(sobj);
	if (obj) {
		var theClass = DOMUtils.getObjectClass(obj);

		if (typeof(theClass) == "string") {
			var arr = theClass.split(' ');
			for (var i = arr.length - 1; i >= 0; i--) {
				if (arr[i] == styleName)
					return;
			}
			arr.push(styleName);
			var strclass = arr.join(' ');
			DOMUtils.setObjectClass(obj, strclass);
		}
		else {
			XtrazDebug.trace("addStyle", styleName,": class not found");
			DOMUtils.setObjectClass(obj, styleName);
		}
	}
	else {
		XtrazDebug.trace("addStyleToObject:", sobj, "not found");
	}
}

XtrazUtils.removeStyleFromObject = function(obj, styleName) {
	obj = DOMUtils.getObject(obj);
	if (obj) {
		var theClass = obj.className;
		if (typeof(theClass) == "string") {
			var arr = theClass.split(' ');
			for (var i = arr.length - 1; i >= 0; i--) {
				if (arr[i] == styleName) {
					arr.splice(i, 1);
					break;
				}
			}
			obj.className = arr.join(' ');
		}
	}
}

XtrazUtils.insertToCommandChain = function(obj, bAddHandler, oCommander, sCommand) {
	obj = DOMUtils.getObject(obj);
	XtrazDebug.assert(obj, "Insert to command chain: no object");
	if (! obj) {
		XtrazDebug.trace("insertToCommandChain: bad object",obj);
		return;
	}
	if (obj.__chain__== 6) {
		XtrazDebug.trace("object", obj.id, "already in command chain");
		return;
	}
	if (obj.__chain__= 6);
	if (bAddHandler == undefined)
		bAddHandler = true;
	if (oCommander == undefined)
		oCommander = null;
	if (sCommand == undefined)
		sCommand = null;
	if (XtrazUtils.isEmpty(obj.Command))
		obj.Command = sCommand;
	if (XtrazUtils.isEmpty(obj.SuperCommander))
		obj.SuperCommander =oCommander;
	if (typeof(obj.obeyCommand) != "function") {
		obj.obeyCommand = XtrazUtils.dispatchCommand;
	}
	obj.dispatchCommand = XtrazUtils.dispatchCommand;
	obj.doCommand = XtrazUtils.doCommand;
	if (bAddHandler) {
		var t = obj.tagName;
		if (typeof(t) == 'string' && t.length > 0) {
			t = t.toLowerCase();
			var evt = null;
			if (t == "input")
				t = obj.type;
			switch (t) {
				default:
					evt = "click";
					break;
				case "select":
					evt = "change";
					break;

			}
			if (evt != null) {
				var f = function(e) {
					arguments.callee.commander.doCommand(e);
					return true;
				}
				f.evt = evt;
				f.commander = obj;
				XtrazUI.addEventListener(obj, evt, f);
				XtrazUI.registerAnonListener(obj, evt, f);
			}
		}
	}
}

XtrazUtils.doCommand = function(param) {
	if (! XtrazUtils.isEmpty(this.Command))
		this.dispatchCommand(this.Command, this, param);
	else {
		XtrazDebug.trace("docommand: empty command");
	}
	return false;
}

XtrazUtils.dispatchCommand = function(cmd, p1, p2, p3, p4, p5) {
	try {
		this.SuperCommander.obeyCommand(cmd, p1, p2, p3, p4, p5);
	}
	catch (e) {
	
	}
}

XtrazUtils.addElementHotKey = function(el, keyCode) {
	XtrazDebug.trace(3, "adding element hot key");
	if (! el.mHotKeys) {
		XtrazDebug.trace(3, "creating hotkeys");
		el.mHotKeys = new Array;
		el.tabIndex = 0;
		el.testHotKey = XtrazUtils.testHotKey;
		XtrazUI.addEventListenerObject(el, "keydown", el, "testHotKey");
	}
	el.mHotKeys.push(keyCode);
}

XtrazUtils.removeElementHotKey = function(el, keyCode) {
/*
	if (el.mHotKeys) {
		for (var i = 0; i < el.mHotKeys; i++) {
			if (el.mHotKeys[i] == keyCode) {
				el.mHotKeys.splice(i, 1);
				break;
			}
		}
		if (el.mHotKeys.length == 0) {
			XtrazUI.removeEventListenerObject(el, "keydown", el);
			delete el.mHotKeys;
		}
	} */
}

XtrazUtils.testHotKey = function(e) {
	XtrazDebug.trace("element hotkey test");
	var bCancel = false;
	if (! e)
		e = window.event;
	if (this.disabled) {
		bCancel = true;
	}
	else if (this.mHotKeys && e) {
		var key= XtrazUI.getEventKey(e);
		for (var i = 0; i < this.mHotKeys.length; i++) {
			if (key == this.mHotKeys[i]) {
				bCancel = true;
				this.doCommand();
				break;
			}
		}
	}
	if (e && bCancel) {
		if (bCancel) {
			if (e.preventDefault)
				e.preventDefault();
			else {
				e.cancelBubble = true;
				e.returnValue = false;
			}
		}
	}
	return ! bCancel;
}



XtrazUtils.cloneObject = function(obj, level) {
	var t = typeof(obj);
	if (undefined == level)
		level = 0;
	else if (level > 10) // probably endless recursion because of a circular reference
		return null;
	var ret;
	switch (t) {
		case "string":
		case "number":
		case "boolean":
			ret = obj;
			break;
		default:
			if (obj instanceof Array) {
				ret = new Array(obj.length);
				for (var i = 0; i < obj.length; i++) {
					ret[i] = XtrazUtils.cloneObject(obj[i], level + 1);
				}
			}
			else if (obj instanceof Date) {
				ret = new Date();
				ret.setTime(obj.getTime());
			}
			else if (obj instanceof (Object)) {
				if (obj) {
					ret = new Object;
					for (var key in obj) {
						ret[key] = XtrazUtils.cloneObject(obj[key], level + 1);
					}
				}
				else if (obj == '') {
					ret = '';
				}
				else {
					ret = null;
				}
			}
			
			break;
	}
	return ret;	
}


XtrazUtils.trimString = function(sInString, bFront, bBack) {
	var len = arguments.length;
	if (sInString) {
		if (len < 3)
			bBack = true;
		if (len < 2)
			bFront = true;
		if (bFront)
			sInString = sInString.replace( /^\s+/g, "" );// strip leading
		if (bBack)
			sInString = sInString.replace( /\s+$/g, "" );// strip trailing
	}
	else {
		sInString = '';
	}
	return sInString;
}

XtrazUtils.isNull = function (obj) {
	return (obj == null) || (obj == undefined);
}

XtrazUtils.makeString = function(obj) {
	var ret = '';
	if (XtrazUtils.isNonEmpty(obj))
		ret = String(obj);
	return ret;		
}

XtrazUtils.UCFirst = function(str) {
	str = String(str);
	var inSpace = true;
	var len = str.length;
	var ret = '';
	var ch;
	for (var i = 0; i < len; i++) {
		ch = str.charAt(i);
		if (ch == ' ' || ch == '\t')
			inSpace = true;
		else {
			if (inSpace)
				ch = ch.toUpperCase();
			else
				ch = ch.toLowerCase();
			inSpace = false;
		}
		ret += ch;
	}
	return ret;
}

XtrazUtils.isEmpty = function(obj) {
	var t = typeof(obj);
	if (t == "string") {
		ret = (obj.length == 0);
	}
	else {
		ret = XtrazUtils.isNull(obj);
	}
	return ret;
}

XtrazUtils.isNonEmpty = function(obj) {
	var ret = false;
	try {
		var t = typeof(obj);
		switch (t) {
			case "number":
			case "boolean":
				ret = true;
				break;
			case "string":
				ret = (obj.length > 0);
				break;
		}
	}
	catch (e) {
	
	}
	return ret;
}

XtrazUtils.random = function(from, to) {
	switch (arguments.length) {
		case 0:
			from = 0;
			to =0xEFFFFFFF;
			break;
		case 1:
			to =Number(from);
			from = 0;
			break;
		default:
			from = Number(from);
			to = Number(to);
			break;
	}
	if (from == to)
		return from;

	var seed;
	do {
		seed = Math.random();
	} while (seed == 0);
	var limit = to - from;
	if (limit < 0)
		limit = -limit;
	seed = Math.round(0xEFFFFFF / seed);
	seed %= limit;
	return seed + from;
}


XtrazUtils.getLastDayOfMonth = function(aDate) {
	var d = new Date;
	d.setTime(aDate.getTime());

	var m = d.getMonth();
	if (m < 11)
		m++;
	else {
		m = 0;
		d.setFullYear(d.getFullYear() + 1);
	}
	d.setMonth(m);
	d.setDate(1);
	d.setHours(0);
	d.setMinutes(0);
	d.setSeconds(1);

	d.setTime(d.getTime() - 80000);
	return d;
}

XtrazUtils.printHTML = function(html, css) {
	var win = window.open("about:blank", "_blank", "width=10,height=10");
	if (win) {
		win.moveTo(-200, -200);
		var doc = win.document;
		doc.open();
		doc.write("<html><head>");
		if (css) {
			doc.write("<LINK REL=STYLESHEET TYPE='text/css' href='" + css + "'' />");
		}
		doc.write("</head><body>");
		doc.write(html);
		doc.write("</body></html>");
		doc.close();
		win.print();
		win.close();
////			body.removeChild(f);
	}
	else {
		XtrazDebug.trace("printHTML: failed to print");	
	}
}

//********* Array functions ************//

XtrazUtils.indexInArray = function(arr, val, field, start) {
	if (arguments.length < 4)
		start = 0;
	try {
		var len = arr.length;
		var bFound = false;
		for (var i = start; i < len; i++) {
			if (field != undefined)
				bFound = arr[i][field] == val;
			else
				bFound = arr[i] == val;
			if (bFound)
				return i;
		}
	}
	catch (e) {
	
	}
	return -1;
}

XtrazUtils.arrayContains = function(arr, val, field) {
	var ind = XtrazUtils.indexInArray(arr, val, field);
	return (ind >= 0);
}

XtrazUtils.findInArray = function(arr, val, field) {
	var ret = null;
	var ind = XtrazUtils.indexInArray(arr, val, field);
	if (ind >= 0) {
		ret = arr[ind];
	}
	return ret;
}

XtrazUtils.removeFromArray = function(arr, val, field, bAll) {
	if (arguments.length < 4)
		bAll = true;
	var bOnce = ! bAll;
	var ret = null;
	var start = 0;
	while (1) {
		var ind = XtrazUtils.indexInArray(arr, val, field, start);
		if (ind >= 0) {
			ret = arr[ind];
			arr.splice(ind, 1);
		}
		if (bOnce || (ind < 0))
			break;
		start = ind;
	}
	return ret;
}

//********* End Array functions ************//


//*********** KeyValueMap helper object *********//
XtrazUtils.KeyValueMap = function() {
	this._map = new Object;
}

XtrazUtils.KeyValueMap.prototype = new Object;

XtrazUtils.KeyValueMap.prototype.adopt = function(obj) {
	if (this._map) {
		delete this._map;
	}
	this._map = obj;
}

XtrazUtils.KeyValueMap.prototype.map = function() {
	var arg1, arg2;
	if (arguments.length == 1) {
		arg1 = arguments[0];
		for (var key in arg1) {
			this._map[key] = arg1[key];
		}
	}
	else {
		for (var i = 1; i < arguments.length; i+=2) {
			this._map[arguments[i-1]] = arguments[i];
		}
	}
}

XtrazUtils.KeyValueMap.prototype.findValue = function(sKey) {
	var ret = this._map[sKey];
	if (undefined == ret)
		ret = null;
	return ret;
}

XtrazUtils.KeyValueMap.prototype.findKey = function(sValue) {

	for (var key in this._map) {
		if (this._map[key] == sValue)
			return key;
	}
	return null;
}
