var TAB_IMAGES_PATH = "box://Xtraz/zlango7/theme/zlango7/images/tab/";

/**
 * Tab's constructor.
 *
 * @param  _gadget the tab gadget
 */
function component (_gadget) 
{ 
	this.gadget = _gadget; 
	this.selectedState = false;
	this.widthVal = null;
}

/**
 * When tab is instantiated, selects it if selected="true".
 *
 */
component.prototype.onInitialized = function ()
{
	this.gadget.zIndex = Number(this.gadget.getAttribute("index"));
	var selected = false;
	if (this.gadget.getAttribute("selected") == "true") {
		selected = true;
		this.gadget.parent.selectTab(this.gadget);
	}
	this.gadget.setSelectedState(selected);
}

/**
 * Sets the style to selected or unselected mode.
 *
 * @param  selected true or false.
 */
component.prototype.setSelectedState = function (selected)
{
	var textLabel = this.gadget.getPartById("label");
	var type = this.gadget.getAttribute("type");

	if (!this.widthVal) {
		textLabel.setStyle("fontBold", "true");
		this.widthVal = textLabel.boxWidth;
	}

	if (selected) {
		var leftImageName;
		var rightImageName;
		var middleImageName;

		if(type == "EXTRA") {
			leftImageName = "tab_extra_selected_left.png";
			rightImageName = "tab_extra_selected_right.png"
			middleImageName = "tab_extra_selected_middle.png"
		} else {
			leftImageName = "tab_selected_left.png";
			rightImageName = "tab_selected_right.png"
			middleImageName = "tab_selected_middle.png"
		}
	
		if (shell.zlangoGlobals.rtl)
		{
			this.gadget.setAttribute("leftImageSrc", TAB_IMAGES_PATH + rightImageName);
		}
		else
		{
			this.gadget.setAttribute("leftImageSrc", TAB_IMAGES_PATH + leftImageName);		
		}
		this.gadget.setAttribute("imageSrc", TAB_IMAGES_PATH + middleImageName);
		if (shell.zlangoGlobals.rtl)
		{
			this.gadget.setAttribute("rightImageSrc", TAB_IMAGES_PATH + leftImageName);
		}
		else
		{
			this.gadget.setAttribute("rightImageSrc", TAB_IMAGES_PATH + rightImageName);
		}
		if(type == "EXTRA") {
			textLabel.setStyle("fill", "url(#FILL_EXTRA_SELECTED)");
		} else {
			textLabel.setStyle("fill", "url(#FILL_SELECTED)");
		}
		textLabel.setStyle("fontBold", "false");
		this.selectedState = true;
	} else {
		var leftImageName;
		var rightImageName;
		var middleImageName;
		
		if(type == "EXTRA") {
			leftImageName = "tab_extra_unselected_left.png";
			rightImageName = "tab_extra_unselected_right.png"
			middleImageName = "tab_extra_unselected_middle.png"
		} else {
			leftImageName = "tab_unselected_left.png";
			rightImageName = "tab_unselected_right.png"
			middleImageName = "tab_unselected_middle.png"
		}
	
		if (shell.zlangoGlobals.rtl)
		{
			this.gadget.setAttribute("leftImageSrc", TAB_IMAGES_PATH + rightImageName);
		}
		else
		{
			this.gadget.setAttribute("leftImageSrc", TAB_IMAGES_PATH + leftImageName);
		}
		this.gadget.setAttribute("imageSrc", TAB_IMAGES_PATH + middleImageName);
		if (shell.zlangoGlobals.rtl)
		{
			this.gadget.setAttribute("rightImageSrc", TAB_IMAGES_PATH + leftImageName);	
		}
		else
		{
			this.gadget.setAttribute("rightImageSrc", TAB_IMAGES_PATH + rightImageName);	
		}
		
		if(type == "EXTRA") {
			textLabel.setStyle("fill", "url(#FILL_EXTRA_UNSELECTED)");
		} else {
			textLabel.setStyle("fill", "url(#FILL_UNSELECTED)");
		}
		textLabel.setStyle("fontBold", "false");
		textLabel.setStyle("cursor", "pointer");
		/*
		if (this.widthVal) {
			textLabel.setStyle("width", this.widthVal);
		}
		*/
		this.selectedState = false;
	}
}

/**
 * When tab is clicked, tell its parent that it was clicked.
 *
 */
component.prototype.onClick = function ()
{
	this.gadget.parent.clickedTab(this.gadget);
}

/**
 * Returns the index of the tab in the tab set, or -1 on error.
 *
 */
component.prototype.getTabIndex = function ()
{
	var tempTab = this.gadget.parent.firstChild;
	var tabIndex = 0;
	while (tempTab != null) {
		if (tempTab.tag != "tab") {
			tempTab = tempTab.nextSibling;
			continue;
		}
		if (this.gadget == tempTab) {
			return tabIndex;
		}
		tabIndex++;
		tempTab = tempTab.nextSibling;
	}
	return -1;
}