/**
 * Tab Panel's constructor.
 *
 * @param  _gadget the tab panel gadget
 */
function component (_gadget) 
{ 
	this.gadget = _gadget; 
}

/**
 * Set up the tab panel when instantiated, showing the selected panel.
 *
 */
component.prototype.onInitialized = function ()
{
	this.gadget.hidden = true;
	var tempPanel = this.gadget.parent.firstChild;
	var panelIndex = 0;
	while (tempPanel != null) {
		if (this.gadget == tempPanel) {
			if (this.gadget.parent.parent.getTabSet().getSelectedTab().getTabIndex() 
			== panelIndex) {
				this.gadget.parent.setShowingPanel(this.gadget);
				this.gadget.hidden = false;
			}
			break;
		}
		tempPanel = tempPanel.nextSibling;
		panelIndex++;
	}
}

/**
 * Show or hide the tab panel.
 *
 * @param  value If true show. If false hide.
 */
component.prototype.setVisible = function (value)
{
	this.gadget.hidden = !value;
}


/**
 * Get category panel.
 *
 */
component.prototype.getCategoryPanel = function ()
{
	return this.gadget.getBoxByTag("categoryPanel");
}