/**
 * Zlango's constructor.
 *
 * @param  _gadget the zlango gadget
 */
shell.gConnector = null;

function component (_gadget)
{
 this.gadget = _gadget;
 this.callbackObj = null;
 this.connector = null;
 this.wordMap = null;
 this.filesPath = null;
 this.language = null;

 var zlangoGlobals = new Object();
 if (zlangoGlobals)
 {
 	shell.addDOMObject("zlangoGlobals", zlangoGlobals);
 }
}

/**
 * Zlango Initialization function called by ICQ. Sets up paths and globals.
 * builds XML objects.
 *
 * @param  conector connects to data.
 */
component.prototype.OnInitXtra = function( conector )
{
 this.connector = conector;
 shell.gConnector= this.connector;
 var xtrazId = "<Q><PluginID>UISite</PluginID><SrvID>Zlango</SrvID></Q>";
 var LoginXml = "Zlango7";
 var callbackObj = this.connector.NotifyPlugin(xtrazId,LoginXml);
 
 this.wordMap = callbackObj.WordMap;
 this.callbackObj = callbackObj;
 this.filesPath = callbackObj.FilesPath;
 this.language = callbackObj.Language;

 this.filesPath = "file://" + this.filesPath.replace("/\\/g", "/") + "/";

 this.dataPath =  this.filesPath + "content/zlango7/";
 this.categoryImagesPath = this.filesPath + "theme/zlango7/categories/";

 shell.zlangoGlobals.webHonUrl = this.gadget.getAttribute("web_hon_url");
 shell.zlangoGlobals.webUrl = this.gadget.getAttribute("web_url");
 shell.zlangoGlobals.letters = this.gadget.getAttribute("letters");
 shell.zlangoGlobals.strings = new Object();
 shell.zlangoGlobals.strings.next = this.gadget.getAttribute("str_next");
 shell.zlangoGlobals.strings.previous = this.gadget.getAttribute("str_previous");
 
 shell.zlangoGlobals.logUrl = this.gadget.getAttribute("log_url");
 
 shell.zlangoGlobals.rtl = this.language == "he-il"; // Boolean: true means it is an RTL language

 this.wordListForShortcuts = Array();

 for (var i = 0; i < shell.zlangoGlobals.letters.length; i++) {
 	this.wordListForShortcuts[i] = Array();
 }


	var objXML = new ActiveXObject("MSXML2.DOMDocument.3.0");
	objXML.async = false;
	objXML.load(this.dataPath + this.language + "/categories.xml");

	this.categoriesDomObject = objXML;
	
	var objXML2 = new ActiveXObject("MSXML2.DOMDocument.3.0");
	objXML2.async = false;
	objXML2.load(this.dataPath + this.language + "/messages.xml");
	
	this.readyMessagesDomObject = objXML2;
	
	var objXML3 = new ActiveXObject("MSXML2.DOMDocument.3.0");
	objXML3.async = false;
	
	objXML3.load(this.dataPath + this.language + "/categories_dict.xml");
	
	this.dictionaryDomObject = objXML3;
	
	var objXML4 = new ActiveXObject("MSXML2.DOMDocument.3.0");
	objXML4.async = false;
	objXML4.load(this.dataPath + this.language + "/categories_extra.xml");
	
	this.categoriesExtraDomObject = objXML4;
	
	var objXML5 = new ActiveXObject("MSXML2.DOMDocument.3.0");
	objXML5.async = false;
	objXML5.load(this.dataPath + this.language + "/categories_extra_dict.xml");
	
	this.dictionaryExtraDomObject = objXML5;

	this.composeCategoryList = this.gadget.buildCategoryDom("COMPOSE");
	
	this.extraCategoryList = this.gadget.buildCategoryDom("EXTRA");
	
	this.gadget.sortShortcutWordLists();
	
	this.readyMessagesCategoryList = this.gadget.buildCategoryDom("READY_MESSAGES");
	
	this.gadget.loadSavedPopupPosition();
	
	var screenName = parseInt(this.connector.GetIMOwnerData("SCREEN_NAME"), 11) * 17;
	this.screenName = screenName;

    //debugger;
}

component.prototype.onShutDown = function (reason)
{
	debugger;
}

component.prototype.getConnector = function ()
{
	return this.connector;
}

component.prototype.getLanguage = function ()
{
	return this.language;
}

component.prototype.getWordListForShortcuts = function ()
{
	return this.wordListForShortcuts;
}

component.prototype.getReadyMessagesDomObject = function ()
{
	return this.readyMessagesDomObject;
}

component.prototype.getComposeCategoryList = function ()
{
	return this.composeCategoryList;
}

component.prototype.getExtraCategoryList = function ()
{
	return this.extraCategoryList;
}

component.prototype.getComposeCategory = function (categoryID)
{
	for (var i = 0; i < this.composeCategoryList.length; i++) {
		if ( this.composeCategoryList[i].id == categoryID) {
			return this.composeCategoryList[i];
		}
	}
	return null;
}

component.prototype.getExtraCategory = function (categoryID)
{
	for (var i = 0; i < this.extraCategoryList.length; i++) {
		if ( this.extraCategoryList[i].id == categoryID) {
			return this.extraCategoryList[i];
		}
	}
	return null;
}

component.prototype.getReadyMessagesCategoryList = function ()
{
	return this.readyMessagesCategoryList;
}

component.prototype.getReadyMessagesCategory = function (categoryID)
{
	for (var i = 0; i < this.readyMessagesCategoryList.length; i++) {
		if ( this.readyMessagesCategoryList[i].id == categoryID) {
			return this.readyMessagesCategoryList[i];
		}
	}
	return null;
}

function sortByLabel(a, b) {
    var x = a.Label.toLowerCase();
    var y = b.Label.toLowerCase();
    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
}


component.prototype.sortShortcutWordLists = function ()
{
	var wordLists = this.wordListForShortcuts;
	
	for (var i = 0; i < wordLists.length; i++) {
		wordLists[i].sort(sortByLabel);	
	}
}

/**
 * Gets a word object from the word map and returns it.
 *
 * @param  wordID the ID of the word to get.
 */
component.prototype.getWord = function (wordID)
{
 	var word = this.wordMap(wordID);
 	return word;
}

/**
 * Gets a word by synonym.
 *
 * @param  syn a synonym.
 */
component.prototype.getWordBySynonym = function (syn)
{
	//syn = syn.toLowerCase(); // We no longer need to force to lowercase, since the function can take uppercase?
	return this.callbackObj.GetWordBySynonym(syn);
}

/**
 * Sends a word to ICQ to be displayed.
 *
 * @param  wordLabel the word to insert.
 */
component.prototype.sendWord = function (wordLabel)
{
 wordLabel = wordLabel.toLowerCase();
 this.callbackObj.InsertZlangoWord(wordLabel);
}

/**
 * Sends a word to ICQ to be displayed (by synonym).
 *
 * @param  syn a synonym to insert.
 */
component.prototype.sendWordBySynonym = function (syn)
{
 this.gadget.sendWord(syn);
}

/**
 * Constructor for a Category object.
 *
 * @param  index numerical index.
 * @param  id category id string.
 * @param  imagePath the category image.
 * @param  label the category label.
 */
function Category (index, id, imagePath, label, wordObjects)
{
	this.index = index;
	this.id = id;
	this.imagePath = imagePath;
	this.label = label;
	this.wordObjects = wordObjects;
}

/**
 * Get category list from XML data.
 *
 * @param  type the type of category (Compose, Ready Messages).
 */
component.prototype.buildCategoryDom = function (type)
{
	var categoryNodes;
	
	if (type == "COMPOSE") {
		var dictionaryNodes = this.dictionaryDomObject.documentElement.selectNodes("categories")[0].selectNodes("category");
		categoryNodes = this.categoriesDomObject.documentElement.selectNodes("category");
	} else if (type == "EXTRA") {
		var dictionaryNodes = this.dictionaryExtraDomObject.documentElement.selectNodes("categories")[0].selectNodes("category");
		categoryNodes = this.categoriesExtraDomObject.documentElement.selectNodes("category");
	} else if (type == "READY_MESSAGES") {
		categoryNodes = this.readyMessagesDomObject.documentElement.selectNodes("category");
	}

	var categoryList = new Array();
	for (var i = 0; i < categoryNodes.length; i++) {
		var label;
		var wordNodes = null;
		var wordObjects = null;
		if (type == "COMPOSE") {
			label = dictionaryNodes[i].getAttribute("label");
			wordNodes = this.categoriesDomObject.documentElement.selectNodes("category[@id='" + categoryNodes[i].getAttribute("id") + "']/word");
			wordObjects = this.gadget.createWordObjectsArray(wordNodes);
		} else if (type == "EXTRA") {
			label = dictionaryNodes[i].getAttribute("label");
			wordNodes = this.categoriesExtraDomObject.documentElement.selectNodes("category[@id='" + categoryNodes[i].getAttribute("id") + "']/word");
			wordObjects = this.gadget.createWordObjectsArray(wordNodes);
		} else if (type == "READY_MESSAGES"){
			label = categoryNodes[i].getAttribute("label");
		}
		
// ---------------------------------------------------------------------------------------------------------------------------//		

		var USE_NEW_RESOURCE_BASED_ICONS = true; // If set to true, fixes icon flash when src is set to file path.
		// But there is a new weird bug then, where icons don't appear at all in the categoryPanel.
		// Set to false to use old method with white flashes.
	
		if (USE_NEW_RESOURCE_BASED_ICONS)
		{
			// A. This new code uses category icons that are pre-created in the library's resources. It works great and eliminates the loading delay.
			// But it causes a strange bug: the category panel doesn't appear until you rollover an icon, and then only in UPWARD mode.
			
			// Create category bitmap:
	    	var categoryBitmap = shell.factory.createBitmap(type + "_BITMAP_" + i, this.categoryImagesPath + categoryNodes[i].getAttribute("image"), this.scene);
		    if (categoryBitmap)
		    {
		        // Set the bitmap's max size:
		        categoryBitmap.setThumbSize(30, 30);
		
				// Add the new bitmap resource into our scene's library:
		        var lib = this.scene.library;
		        if (lib)
		        {
					lib.addResource(categoryBitmap);
		        }
		    }
	
			var category = new Category(i, categoryNodes[i].getAttribute("id"),	"#" + type + "_BITMAP_" + i, label, wordObjects);
			
		}
		else
		{
			// B. This old code sets category icons by setting the source to a disk path, but forcing a new disk read and causing a delay in display:
			var category = new Category(i, categoryNodes[i].getAttribute("id"),	this.categoryImagesPath + categoryNodes[i].getAttribute("image"), label, wordObjects);
		}

// ---------------------------------------------------------------------------------------------------------------------------//		
	
		categoryList.push(category);
		
	}
	
	return categoryList;
}

component.prototype.createWordObjectsArray = function(categoryWordNodes)
{
	var wordObjectsArray = Array();
	for (var i = 0; i < categoryWordNodes.length; i++) {
		var aWordObject = this.gadget.getWord(categoryWordNodes[i].getAttribute("id"));
		if (aWordObject)
		{
			wordObjectsArray[i] = aWordObject;
			this.gadget.pushWordToShortcutsList(wordObjectsArray[i]);
		}
		else
		{
			// The word id listed under the category does not appear in the table of words. So we don't add it to the category.
			//this.scene.alert (categoryWordNodes[i].getAttribute("id"), "Bad word id", 1);
		}
	}
	return wordObjectsArray;
}

component.prototype.pushWordToShortcutsList = function (word)
{
	if (word.Shortcut == "")
	{
		return;
	}
	
	var firstLetter = word.Label.charAt(0).toLowerCase();
	var lowerLetters = shell.zlangoGlobals.letters.toLowerCase();
	var indexOfFirstLetter = lowerLetters.indexOf(firstLetter);
	// If the word begins with a non-alphabetic character, add it to the special (asterisk) list, which is after the last letter:
	if (indexOfFirstLetter == -1)
	{
		indexOfFirstLetter = lowerLetters.length - 1;
	}
	var thisLetterList = this.wordListForShortcuts[indexOfFirstLetter];
	for (var i = 0; i < thisLetterList.length; i++) {
		if (thisLetterList[i].Label == word.Label) {
			return;
		}
	}
	thisLetterList.push(word);		
}


component.prototype.loadSavedPopupPosition = function ()
{
	// If the user moved the ICQ box since last time Xtra was open, then reset our popup position to default:
	var savedICQX = this.gadget.getPref("icq_x");
	var savedICQY = this.gadget.getPref("icq_y");
	var icqBox = this.scene.rootBox;
	if (Number(savedICQX) != icqBox.screenX || Number(savedICQY) != icqBox.screenY)
	{
		this.gadget.setPref("popup_x", "");
		this.gadget.setPref("popup_y", "");
	}

	// If the user moved the popup to a custom position, restore that position:
	var savedX = this.gadget.getPref("popup_x");
	var savedY = this.gadget.getPref("popup_y");
	if ((savedX != "") && (savedY != ""))
	{
		shell.zlangoGlobals.savedUserPopupPosition = new Object();
		shell.zlangoGlobals.savedUserPopupPosition.x = Number(savedX);
		shell.zlangoGlobals.savedUserPopupPosition.y = Number(savedY);
	}
}

	
	
/**
 * Get a saved pref
 *
 * @param  key String name of pref key
 */
component.prototype.getPref = function (key)
{
	var isPerOwner = true;
	var prefs = this.connector.GetPrefsValues(isPerOwner);
	var vars = prefs.split("&"); 
	for (var i=0; i<vars.length; i++)
	{ 
		var pair = vars[i].split("="); 
		if (pair[0] == key)
		{ 
			return pair[1]; 
		} 
	}
	return "";
}

/**
 * Save a pref
 *
 * @param  key String name of pref key
 * @param  value Pref value
 */
component.prototype.setPref = function (key, value)
{
	var isPerOwner = true;
	var prefs = this.connector.GetPrefsValues(isPerOwner);
	var vars = prefs.split("&"); 
	
	var existed = false; // Did the pref already exist? If so, we will update its value. If not, we will add a new pref.
	for (var i=0; i<vars.length; i++)
	{ 
		var pair = vars[i].split("="); 
		if (pair[0] == key)
		{ 
			existed = true;
			vars[i] = key + "=" + value;
			break;
		} 
	}
	
	if (!existed)
	{
		var pairAsString = key + "=" + value;
		vars.push(pairAsString);
	}
	var rebuiltVars = vars.join("&");
	this.connector.SetPrefsValues(isPerOwner, rebuiltVars);
}

/**
 * Delete a pref
 *
 * @param  key String name of pref key
 */
component.prototype.deletePref = function (key)
{
	var isPerOwner = true;
	var prefs = this.connector.GetPrefsValues(isPerOwner);
	var vars = prefs.split("&"); 
	
	for (var i=0; i<vars.length; i++)
	{ 
		var pair = vars[i].split("="); 
		if (pair[0] == key)
		{ 
			vars.splice(i,0); // Remove the pair
			break;
		} 
	}
	
	var rebuiltVars = vars.join("&");
	this.connector.SetPrefsValues(isPerOwner, rebuiltVars);
}

component.prototype.setUpLogger = function ()
{
	this.logger = this.scene.createBox("image");
	this.logger2 = this.scene.createBox("image");
	this.logger3 = this.scene.createBox("image");
	this.logger.hidden = true;
	this.logger.hidden2 = true;
	this.logger.hidden3 = true;
	this.gadget.addChild(this.logger);
	this.gadget.addChild(this.logger2);
	this.gadget.addChild(this.logger3);
	this.sessionId = Math.ceil(Math.random() * 100000000000000000);
	
	this.gadget.logSession();
}

component.prototype.logSession = function ()
{
	this.gadget.logEvent("OPENXTRA", "");
}

component.prototype.logWord = function (word)
{
	this.gadget.logEvent("WORD", word);
}

component.prototype.logReadyMessage = function (message)
{
	this.gadget.logEvent("MSG", message); // Should be delimited with plus signs
}

component.prototype.logDemo = function ()
{
	this.gadget.logEvent("DEMO", "");
}

component.prototype.logEvent = function (action, data)
{
   

	// Only log first event of each type per Xtra session:
	// -----------------------------------------------------------
	switch (action)
	{
		case "WORD":
			if (this.loggedIcon)
			{
				//return;
			}
			else
			{
				//this.loggedIcon = true;
			}
			break;
	
		case "MSG":
			if (this.loggedMessage)
			{
				//return;
			}
			else
			{
				//this.loggedMessage = true;
			}
			break;
	
		case "DEMO":
			if (this.loggedDemo)
			{
				return;
			}
			else
			{
				//this.loggedDemo = true;
			}
			break;
	}
	// -----------------------------------------------------------

	var logUrl = shell.zlangoGlobals.logUrl + "?";
	logUrl += "action=" + action;
	//logUrl += "&data=" + data; // Don't send the actual words entered
	logUrl += "&user=" + this.screenName;
	logUrl += "&session=" + this.sessionId;
	logUrl += "&language=" + this.language;
	logUrl += "&date=" + Date().replace(/ /g, "+"); // Includes time.
	

/*
	switch (action)
	{
		case "WORD":
			if (!this.loggedIcon)
			{
				this.loggedIcon = true;
				logUrl += "&first=1";
			}
			break;
	
		case "MSG":
			if (!this.loggedMessage)
			{
				this.loggedMessage = true;
				logUrl += "&first=1";
			}
			break;
	
		case "DEMO":
			if (!this.loggedDemo)
			{
				this.loggedDemo = true;
				logUrl += "&first=1";
			}
			break;
	}
*/
	if((action == "WORD" && this.loggedIcon == undefined) || (action == "MSG" && this.loggedMessage == undefined) || (action == "OPENXTRA") || (action == "DEMO" && this.loggedDemo == undefined)) {
	    this.logger.src = logUrl; // This triggers an http request to the logUrl. We don't care about the result.
	    
	    if(action == "WORD") {
	        this.loggedIcon = true;
	    } else if(action == "MSG") {
	        this.loggedMessage = true;
	    } else if(action == "DEMO") {
	        this.loggedDemo = true;
	    }
	}
	
	var iconsNumber = 1;
	
	if(action == "MSG") {
	    iconsNumber = data.split("+").length;
	}
	
	if(action == "WORD" || action == "MSG") {
	    var logUrl2 = shell.zlangoGlobals.logUrl + "?";
	    logUrl2 += "action=totalIcons";
	    logUrl2 += "&iconsNumber=" + iconsNumber;
	    logUrl2 += "&user=" + this.screenName;
	    logUrl2 += "&session=" + this.sessionId;
	    logUrl2 += "&language=" + this.language;
	    logUrl2 += "&temp=" + (new Date().getTime()); //Because we using a IMG tag we cant send the same url twice so we need a uid;
	    
	    this.logger2.src = logUrl2; // This triggers an http request to the logUrl. We don't care about the result.
	    
	    var logUrl3 = shell.zlangoGlobals.logUrl + "?";
	    logUrl3 += "action=icons";
	    logUrl3 += "&iconId=" + data; // Don't send the actual words entered
	    logUrl3 += "&language=" + this.language;
	    logUrl3 += "&date=" + Date().replace(/ /g, "+"); // Includes time.
	    logUrl3 += "&temp=" + (new Date().getTime()); //Because we using a IMG tag we cant send the same url twice so we need a uid;
	    
	    this.logger3.src = logUrl3; // This triggers an http request to the logUrl. We don't care about the result.
	}
}