/***************************************************************************

 File Name:   inputContext.js

****************************************************************************
C O P Y R I G H T   A N D   C O N F I D E N T I A L I T Y   N O T I C E
****************************************************************************

  Copyright (c) 2008 AOL, LLC.  All rights reserved.
  This software contains valuable confidential and proprietary
  information of AOL, LLC. and is subject to applicable licensing
  agreements.  Unauthorized reproduction, transmission or
  distribution of this file and its contents is a violation of
  applicable laws.

                      A O L    C O N F I D E N T I A L

***************************************************************************/

component.prototype.initContentMenu = function()
{
    var menuPopup = this._gadget.scene.createBox("menuPopup");
    if (menuPopup)
    {
        menuPopup.id = "_inputContext";
        menuPopup.setAttribute("popupAlign", "cursor_left_top");
        menuPopup.setAttribute("showNoActivate", "true");
        menuPopup.setStyle("cursor", "arrow");
        this.addMenuItem(menuPopup, "undo", "input.contextMenu.undo", "Undo", "input.contextMenu.accel.undo", "Ctrl + Z", "toolkit:UndoText");
        this.addMenuSeparator(menuPopup);
        this.addMenuItem(menuPopup, "cut", "input.contextMenu.cut", "Cut", "input.contextMenu.accel.cut", "Ctrl + X", "toolkit:CutText");
        this.addMenuItem(menuPopup, "copy", "input.contextMenu.copy", "Copy", "input.contextMenu.accel.copy", "Ctrl + C", "toolkit:CopyText");
        this.addMenuItem(menuPopup, "paste", "input.contextMenu.paste", "Paste", "input.contextMenu.accel.paste", "Ctrl + V", "toolkit:PasteText");
        this.addMenuItem(menuPopup, "delete", "input.contextMenu.delete", "Delete", "input.contextMenu.accel.delete", "Del", "toolkit:DeleteText");
        this.addMenuSeparator(menuPopup);
        this.addMenuItem(menuPopup, "selectAll", "input.contextMenu.selectAll", "Select All","input.contextMenu.accel.selectAll", "Ctrl + A", "toolkit:SelectAllText");
        this._gadget.scene.rootBox.addChild(menuPopup);
        this.setUpdateValues(menuPopup);
    }
}
component.prototype.addMenuSeparator = function(menuPopup)
{
    if (menuPopup)
    {
        var aolMenuSeparator = this._gadget.scene.createBox("aolMenuSeparator");
        if (aolMenuSeparator)
        {
            menuPopup.addContentChild(aolMenuSeparator);
        }
    }
}
component.prototype.addMenuItem = function(menuPopup, id, label, defaultLabel, accelText, defaultAccelText, action)
{
    if (menuPopup)
    {
        var aolMenuItem = this._gadget.scene.createBox("aolMenuItem");
        if (aolMenuItem)
        {
            aolMenuItem.id = id;
            var menuLabel = appUtils.getString("ee://aol/boxelyToolkit", label);
            if (menuLabel == null)
                menuLabel = defaultLabel;
            aolMenuItem.setAttribute("label", menuLabel);
            var menuAccelText = appUtils.getString("ee://aol/boxelyToolkit", accelText);
            if (menuAccelText == null)
                menuAccelText = defaultAccelText;
            aolMenuItem.setAttribute("accelText", menuAccelText);
            if (action)
            {
                aolMenuItem.addEventHandler("command", action)
            }
            menuPopup.addContentChild(aolMenuItem);
        }
    }
}
component.prototype.setUpdateValues = function(menuPopup)
{
    if (menuPopup)
    {
        var child = menuPopup.firstPopupChild;
        while (child)
        {
            var id = child.id;
            if (id)
                child.disabled = (this._gadget.queryCmdSupported(id)) ? false : true;
            child = child.nextSibling;
        }
    }
}
