//****************************************************************************
//
//     File Name:   scrollbar.js
//
//****************************************************************************
//   C O P Y R I G H T   A N D   C O N F I D E N T I A L I T Y   N O T I C E
//****************************************************************************
//
//      Copyright (c) 2004-2005 America Online, Inc.  All rights reserved.
//      This software contains valuable confidential and proprietary
//      information of America Online, Inc. and is subject to applicable
//      licensing agreements.  Unauthorized reproduction, transmission or
//      distribution of this file and its contents is a violation of
//      applicable laws.
//
//            A M E R I C A   O N L I N E   C O N F I D E N T I A L
//
//****************************************************************************
function component (_gadget)
{
    var autoscrollDir = 0;
    var autoscrollTime = 0;
    var autoscrollDelay = true;
    var isPageScroll = false;
    var offset = 0;
    var trackBox = null;
}

//****************************************************************************
component.prototype.onMouseUp = function()
{
    this._gadget.removeAttribute("autoscroll", true);
}

//****************************************************************************
component.prototype.onTrackClick = function()
{
    isPageScroll = true;

    var event = shell.currentEvent;
    trackBox = this._gadget.getPartById("track");

    if (trackBox)
    {
        //check orientation
        if (trackBox.getStyleString("orient") == "vertical")
        {
            offset = event.boxY;
        }
        else
        {
            offset = event.boxX;
        }

        if (trackBox.pagingDirection == -1 || trackBox.pagingDirection == 1)
        {
            autoscrollDir = trackBox.pagingDirection * trackBox.pageSize;
            autoscrollDelay = true;
            autoscrollTime = this.getMS();
            this._gadget.setAttribute("autoscroll", "true");
        }
    }
}

//****************************************************************************
component.prototype.getScrollUnit = function(autoscrollDir)
{
    var scrollUnit = 0;
    var track = this._gadget.getPartById("track");
    // scroll by 1/10 of the pageSize
    if (track && track.pageSize && track.getAttribute("pageNumRows") == null)
    {
        scrollUnit = (track.pageSize)/10;
    }
    // the scrollbar owner can specify scrollUnit.
    if (this._gadget.parent)
    {
        var unit = this._gadget.parent.getAttribute("scrollUnit");
        if (unit)
        {
            scrollUnit = parseInt(unit);
        }
    }
    if (scrollUnit != 0)
    {
        scrollUnit = autoscrollDir * scrollUnit;
    }
    else
    {
        scrollUnit = autoscrollDir;
    }
    return scrollUnit;
}

//****************************************************************************
component.prototype.onClickUp = function()
{
    isPageScroll = false;
    autoscrollDir = -1;
    autoscrollDelay = true;
    var scrollUnit = this.getScrollUnit(autoscrollDir);
    this.doScroll(scrollUnit);
    autoscrollTime = this.getMS();
    this._gadget.setAttribute("autoscroll", "true");
}

//****************************************************************************
component.prototype.onClickDown = function()
{
    isPageScroll = false;
    autoscrollDir = 1;
    autoscrollDelay = true;
    var scrollUnit = this.getScrollUnit(autoscrollDir);
    this.doScroll(scrollUnit);
    autoscrollTime = this.getMS();
    this._gadget.setAttribute("autoscroll", "true");
}

//****************************************************************************
component.prototype.onFrame = function()
{
    if (autoscrollDelay)
    {
        var newTime = this.getMS();
        if ((newTime-autoscrollTime) > 500)
        {
            autoscrollDelay = false;
        }
    }
    if (!autoscrollDelay)
    {
        var scrollUnit = this.getScrollUnit(autoscrollDir);
        this.doScroll(scrollUnit);
    }
}

//****************************************************************************
component.prototype.getTrackValue = function(value, dir)
{
    var newValue = value;

    if (trackBox)
    {
        mouseLocation = trackBox.coordsToTicks(offset);
        if (trackBox.pagingDirection == 1)
        {
            //check if the value needs to be changed
            if (value < mouseLocation)
            {
                newValue += dir;

                //constrain new value within the range
                if (newValue > mouseLocation)
                {
                    newValue = mouseLocation;
                }
            }
        }
        else if (trackBox.pagingDirection == -1)
        {
            //check if the value needs to be changed
            if (newValue > mouseLocation)
            {
                newValue += dir;

                //constrain new value within the range
                if (newValue < mouseLocation)
                {
                    newValue = mouseLocation;
                }
            }
        }
    }

    return newValue;
}

//****************************************************************************
component.prototype.doScroll = function(dir)
{
    //check if we need to reverse the direction
    if (this._gadget.getAttribute("rtl") == "true")
    {
        dir = -dir;
    }
    
    var value = parseInt(this._gadget.getAttribute("value"));
    var newValue = 0;

    if (isPageScroll)
    {
        newValue = this.getTrackValue(value, dir);
    }
    else
    {
        newValue = value + dir;
        var max = this._gadget.getAttribute("max");

        if (newValue < 0)
        {
            newValue = 0;
        }
        else if (newValue > max)
        {
            newValue = max;
        }
    }
    this._gadget.setAttribute("value", newValue.toString());
}

//****************************************************************************
component.prototype.getMS = function()
{
    var d = new Date();
    var msec = d.getMilliseconds();
    var sec = d.getSeconds();
    var min = d.getMinutes()
    return (min*(1000*60)) + (sec*1000) + msec;
}
