/***************************************************************************

 File Name:   combopopup.js

****************************************************************************
C O P Y R I G H T   A N D   C O N F I D E N T I A L I T Y   N O T I C E
****************************************************************************

  Copyright (c) 2008 AOL, LLC.  All rights reserved.
  This software contains valuable confidential and proprietary
  information of AOL, LLC. and is subject to applicable licensing
  agreements.  Unauthorized reproduction, transmission or
  distribution of this file and its contents is a violation of
  applicable laws.

                      A O L    C O N F I D E N T I A L

***************************************************************************/

function component (_gadget)
{
    this.originalHeight = -1;
}
component.prototype.adjustHeight = function(newHeight)
{
    this.originalHeight = this._gadget.height;
    this._gadget.height = newHeight;
    var container = this._gadget.getPartById("container");
    if (container)
    {
        container.maxHeight = newHeight;
    }                            
}
component.prototype.onShutting = function()
{
    var container = this._gadget.getPartById("container");
    if (this.originalHeight != -1 && container)
    {
        this._gadget.height = this.originalHeight;
        container.maxHeight = "auto";
        this.originalHeight = -1;
    }
}
component.prototype.isSelectable = function(child)
{
    var ret = false;
    if (child && child.disabled == false && child.hidden == false && child.collapsed == false)
    {
        var attr = child.getAttribute("selectablePopupChild");
        if (attr && attr == "true")
        {
            ret = true;
        }
    }
    return ret;
}
component.prototype.getFirstChild = function()
{
    var walk = this._gadget.firstPopupChild;
    while (walk)
    {
        if (this.isSelectable(walk))
        {
            break;
        }
        walk = walk.nextSibling;
    }
    return walk;
}
component.prototype.getLastChild = function()
{
    var walk = this._gadget.firstPopupChild;
    if (walk && walk.parent)
    {
        walk = walk.parent.lastChild;
    }
    else
    {
        walk = null;
    }
    while (walk)
    {
        if (this.isSelectable(walk))
        {
            break;
        }
        walk = walk.previousSibling;
    }
    return walk;
}
component.prototype.selectFirstChild = function()
{
    var firstChild = this.getFirstChild();
    if (firstChild)
    {
        this._gadget.currentPopupChild = firstChild;
    }
}
component.prototype.selectLastChild = function()
{
    var lastChild = this.getLastChild();
    if (lastChild)
    {
        this._gadget.currentPopupChild = lastChild;
    }
}
component.prototype.selectNextChild = function()
{
    var walk = this._gadget.currentPopupChild;
    if (walk == null || walk == this.getLastChild())
    {
        walk = this.getFirstChild();
    }
    else
    {
        walk = walk.nextSibling;
        while (walk)
        {
            if (this.isSelectable(walk))
            {
                break;
            }
            walk = walk.nextSibling;
        }
    }
    if (walk)
    {
        this._gadget.currentPopupChild = walk;
    }
}
component.prototype.selectPreviousChild = function()
{
    var walk = this._gadget.currentPopupChild;
    if (walk == null || walk == this.getFirstChild())
    {
        walk = this.getLastChild();
    }
    else
    {
        walk = walk.previousSibling;
        while (walk)
        {
            if (this.isSelectable(walk))
            {
                break;
            }
            walk = walk.previousSibling;
        }
    }
    if (walk)
    {
        this._gadget.currentPopupChild = walk;
    }
}
component.prototype.onUp = function()
{
    var currentEvent = shell.currentEvent;
    var currentChild = this._gadget.currentPopupChild;
    if (!currentChild)
    {
        this.selectLastChild();
    }
    else
    {
        this.selectPreviousChild();
    }
    this.scrollToCurrentChild();
    if (currentEvent)
    {
        currentEvent.stopPropagation();
    }
}
component.prototype.onDown = function()
{
    var currentEvent = shell.currentEvent;
    var currentChild = this._gadget.currentPopupChild;
    if (!currentChild)
    {
        this.selectFirstChild();
    }
    else
    {
        this.selectNextChild();
    }
    this.scrollToCurrentChild();
    if (currentEvent)
    {
        currentEvent.stopPropagation();
    }
}
component.prototype.scrollToCurrentChild = function()
{
    var container = this._gadget.getPartById("container");
    if (this._gadget.currentPopupChild && container)
    {
        container.scrollToBox(this._gadget.currentPopupChild);
    }
}
