/***************************************************************************

 File Name:   aolDialog.js

****************************************************************************
C O P Y R I G H T   A N D   C O N F I D E N T I A L I T Y   N O T I C E
****************************************************************************

  Copyright (c) 2008 AOL, LLC.  All rights reserved.
  This software contains valuable confidential and proprietary
  information of AOL, LLC. and is subject to applicable licensing
  agreements.  Unauthorized reproduction, transmission or
  distribution of this file and its contents is a violation of
  applicable laws.

                      A O L    C O N F I D E N T I A L

***************************************************************************/

function component (_gadget)
{
}
component.prototype.onInitialized = function()
{
    this.initMenuBar();
}
component.prototype.initMenuBar = function()
{
    var aolWindowContent = this._gadget.getPartById("aolWindowContent");
    if( aolWindowContent )
    {
        var userMenuBar = aolWindowContent.getBoxByTag("aolMenuBar");
        var mainMenuBar = this._gadget.getPartById("__mainMenuBar");
        if( userMenuBar && mainMenuBar )
        {
            var n = userMenuBar.childCount;
            for(var i=0; i<n; i++)
            {
                mainMenuBar.insertChildAt(userMenuBar.getChildAt(0), i);
            }
            if(userMenuBar.id && userMenuBar.id.length > 0)
            {
                mainMenuBar.id = userMenuBar.id;
                userMenuBar.id = "moved_by_aolWindow";
            }
            if (userMenuBar.parent)
            {
                userMenuBar.parent.deleteChild(userMenuBar);
            }
        }
    }
}
component.prototype.onDoubleClickTitlebar = function()
{
    this.toggleMaximized();
}
component.prototype.onAccThemeChange = function()
{
    if (appUtils.accTheme)
    {
        var rootBox = this.scene.rootBox;
        if (rootBox)
        {
            rootBox.setAttribute("translucent", "false")
            var collBox = rootBox.getPartById("titleGroup");
            if (collBox != null)
                collBox.collapsed = true;
            rootBox.chromeless = false;
        }
    }
}
component.prototype.onDoubleClickWindow = function()
{
    var event   = shell.currentEvent;
    var caption = this._gadget.getPartById("titleBar");
    if (event && caption)
    {
        if (event.targetBox == this._gadget &&
            event.frameY < caption.frameY)
        {
            this.toggleMaximized();
        }
    }
}
component.prototype.toggleMaximized = function()
{
    if (this._gadget.getAttribute("maximizable") == "true")
    {
        if (this._gadget.getAttribute("maximized") ==  "false")
            this._gadget.setAttribute("maximized", "true");
        else
            this._gadget.setAttribute("maximized", "false");
    }
}
component.prototype.onClickSystemMenu = function()
{
    var event = shell.currentEvent;
    if (event && (event.button==1 || event.button==2))
    {
        var theBox = event.targetBox;
        if (theBox)
        {
            this.scene.displaySystemMenu(theBox, theBox.screenX, theBox.screenY + theBox.boxHeight);
        }
        event.stopPropagation();
    }
}
component.prototype.onDoubleClickSystemMenu = function()
{
    this.scene.close();
    var event = shell.currentEvent;
    if (event)
    {
        event.stopPropagation();
    }
}
component.prototype.onClickTitleBar = function()
{
    var event = shell.currentEvent;
    if (event && event.button==2)
        this.scene.displaySystemMenu(null, event.screenX, event.screenY);
}
