var _global = new Object;
_global.next = 0;
_global.globals = new Object;
_global.pushGlobal = function() {
	var id = this.next;
	var o = {id: id};
	this.globals[id] = o;
	this.next++;
	return o;
}

_global.popGlobal = function(handle, bKeep) {
	var ret = this.globals[handle];
	if (! bKeep)
		delete this.globals[handle];
	return ret;
}

_global.setTimeout = function(nTimeout, owner, sMethod, p1, p2, p3, p4, p5, p6) {
	return _global.addClient(false, nTimeout, owner, sMethod, p1, p2, p3, p4, p5, p6);
}

_global.setInterval = function(nTimeout, owner, sMethod, p1, p2, p3, p4, p5, p6) {
	return _global.addClient(true, nTimeout, owner, sMethod, p1, p2, p3, p4, p5, p6);
}

_global.addClient = function(bInterval, nTimeout, owner, sMethod, p1, p2, p3, p4, p5, p6) {
	XtrazDebug.assert((typeof(nTimeout) == "number"), "bad timeout passed to global settimeout");
	var o = _global.pushGlobal();
	o.owner = owner;
	o.method = sMethod;
	o.p1 = p1;
	o.p2 = p2;
	o.p3 = p3;
	o.p4 = p4;
	o.p5 = p5;
	o.p6 = p6;

	if (bInterval) {
		o.timer  = setInterval("_global.doInterval(" + o.id + ")", nTimeout);
	}
	else
		o.timer  = setTimeout("_global.doTimeout(" + o.id + ")", nTimeout);
	return o.timer;
}

_global.doTimeout = function(h) {
	var o = _global.popGlobal(h);
	XtrazDebug.assert(o.owner[o.method], "bad callback", o.method, "passed to global settimeout");
	o.owner[o.method](o.p1, o.p2, o.p3, o.p4, o.p5, o.p6);
}

_global.doInterval = function(h) {
	var o = _global.popGlobal(h, true);
	XtrazDebug.assert(o.owner[o.method], "bad callback", o.method, "passed to global settimeout");
	o.owner[o.method](o.p1, o.p2, o.p3, o.p4, o.p5, o.p6);
}

_global.clearInterval = function(id) {
	clearInterval(id);
	var obj;
	for (var key in _global.globals) {
		obj = _global.globals[key];
		if (obj && (obj.timer == id)) {
			delete _global.globals[key];
			break;
		}
	}
}