/**
 * Constructor.
 *
 * @param  _gadget
 */
function component (_gadget) 
{ 
	this.gadget = _gadget; 
	this.currentImageSource = null;
}

/**
 * 
 */
component.prototype.onInitialized = function ()
{

}

/**
 * Adds all of the category images (from a Compose or Ready Messages array) to the stack. 
 *
 * @param categoryList An array of Category objects
 */
component.prototype.addCategoryImages = function (categoryList)
{
	//this.scene.alert("categoryList: " + categoryList.toString(), "addCategoryImages", 1);
	
	for (var i=0; i < categoryList.length; i++)
	{
		this.gadget.addImage(categoryList[i].imagePath);
	}
}

component.prototype.alreadyInitialized = function ()
{
	return this.gadget.childCount > 0;
}

/**
 * Adds an image to the stack 
 *
 * @param imageSource path to image file
 */
component.prototype.addImage = function (imageSource)
{
	var newImage = this.scene.createBox("image");
	this.gadget.addChild(newImage);
	newImage.setStyle("position", "fixed");
	newImage.left = 0;
	newImage.top = 0;
	newImage.src = imageSource;
	newImage.hidden = true;
}


/**
 * Hides all of the images except the one whose src is imageSource
 *
 * @param imageSource path to image file
 */
component.prototype.setCurrentImage = function(imageSource)
{
	//this.scene.alert("this.gadget.childCount: " + this.gadget.childCount, "setCurrentImage", 1);
	
	for (var i=0; i < this.gadget.childCount; i++)
	{
		var child = this.gadget.getChildAt(i);
		
		if(child.src == imageSource)
		{
			child.hidden = false;
		}
		else
		{
			child.hidden = true;
		}
	}
	this.currentImageSource = imageSource;
}

