/**
 * Ready Message Item's constructor.
 *
 * @param  _gadget the ready message item gadget
 */
function component (_gadget) { 
	this.gadget = _gadget; 
	this.eventListener = null;
}

/**
 * When the ready message item is instantiated, set its event listener to
 * be readyMessagesPanel.
 *
 */
component.prototype.onInitialized = function()
{
	this.eventListener = this.gadget.parent.gadgetParent;
}

/**
 * When the ready message item is clicked, select the message
 *
 */
component.prototype.onMouseDown = function ()
{
	this.eventListener.selectReadyMessageItem(this.gadget);
}

/**
 * When the ready message item is rolled over, set its highlight
 *
 */
component.prototype.onMouseOver = function ()
{
	this.eventListener.mouseOverReadyMessageItem(this.gadget);
}

/**
 * When the mouse leaves the ready message item , remove its highlight
 *
 */
component.prototype.onMouseOut = function ()
{
	this.eventListener.mouseOutReadyMessageItem(this.gadget);
}

/**
 * When the ready message item is double-clicked, alert its eventListener to submit the message
 *
 */
component.prototype.onDoubleClick = function ()
{
	this.eventListener.insertMessage();
}
