/**
 * Tab Group's constructor.
 *
 * @param  _gadget the tab group gadget
 */
function component (_gadget) 
{ 
	this.gadget = _gadget;
	this.tabSet = null;
	this.tabPanelSet = null;
}

/**
 * Set the tab group's tab set.
 *
 * @param  tabSet the tab set gadget
 */
component.prototype.setTabSet = function (tabSet)
{
	this.tabSet = tabSet;
}

/**
 * Set the tab group's tab panel set.
 *
 * @param  tabPanelSet the tab panel set gadget
 */
component.prototype.setTabPanelSet = function (tabPanelSet)
{
	this.tabPanelSet = tabPanelSet;
}

/**
 * Return the tab group's tab set.
 *
 */
component.prototype.getTabSet = function ()
{
	return this.tabSet;
}

/**
 * Return the tab group's tab panel set.
 *
 */
component.prototype.getTabPanelSet = function ()
{
	return this.tabPanelSet;
}

/**
 * Show a particular tab panel.
 *
 * @param  tabIndex the index of the tab panel to show.
 */
component.prototype.showPanel = function (tabIndex)
{
	if (this.tabPanelSet) {
		this.tabPanelSet.showPanel(tabIndex);
	}
}