/**
 * Word Button's constructor.
 *
 * @param  _gadget the word button gadget
 */
function component (_gadget) { 
	this.gadget = _gadget; 
	this.gadget.panel = null;
}

/**
 * When clicked, tell the panel that it was clicked.
 *
 */
component.prototype.onClick = function ()
{
	this.gadget.panel.clickWordIcon(this.gadget);
}

/**
 * On mouse over, tell the panel that it was moused-over.
 *
 */
component.prototype.onMouseOver = function ()
{
	this.gadget.panel.onMouseSelect(this.gadget);
}

/**
 * Set this button's style to be selected, or unselected.
 *
 * @param  val If true, selected. If false, unselected.
 */
component.prototype.setSelected = function(val)
{
	if (val) {
		this.gadget.getPartById("container").setStyle("stroke", "#4D9613");
		this.gadget.getPartById("container").setStyle("fill", "#ECFFDF");
		this.gadget.getPartById("container").setStyle("fillCornerRadius", "3");
		this.gadget.getPartById("container").setStyle("strokeWidth", "1");
		this.gadget.getPartById("container").setStyle("strokeCornerRadius", "3");
	} else {
		this.gadget.getPartById("container").removeStyle("stroke");
		this.gadget.getPartById("container").removeStyle("strokeWidth");
		this.gadget.getPartById("container").removeStyle("strokeCornerRadius");
		this.gadget.getPartById("container").removeStyle("fill");
		this.gadget.getPartById("container").removeStyle("fillCornerRadius");
	}
}
