if (typeof(XMLEncoder) != "object") {
	XMLEncoder = new Object;
	XMLEncoder.symbolstring = '';
	XMLEncoder._entities = new Array (
			{ str:"\&amp;", regEncode: /\&/g, regDecode: /\&amp;/g,   symbol:'&', len: 5 }, // must be first
			{ str: "\&lt;",   regEncode: /</g, regDecode: /\&lt;/g, symbol:'<', len:4 }, 
			{ str:"\&gt;",   regEncode: />/g, regDecode: /\&gt;/g, symbol:'>', len:4 }, 
			{ str:"\&quot;",  regEncode: /\"/g, regDecode: /\&quot;/g, symbol:'"', len: 6 }
		);
	
	
	XMLEncoder.encode = function(str) {
		var ret = str;
		var sym, len = XMLEncoder._entities.length;
		for (var i = 0; i < len; i++) {
			sym = XMLEncoder._entities[i];
			if (ret.indexOf(sym.symbol) >= 0)
				ret = ret.replace(sym.regEncode, sym.str);
		}
		
		return ret;
	}
	
	// decode:
	// in: string
	// out: string
	XMLEncoder.decode = function(str) {
		var ret = str;
		var sym, len = XMLEncoder._entities.length;
		for (var i = 0; i < len; i++) {
			sym = XMLEncoder._entities[i];
			if (ret.indexOf(sym.str) >= 0)
				ret = ret.replace(sym.regDecode, sym.symbol);
		}
		
		return ret;
	}
}
