var undefined; // keep undefined


/********** XtrazDebug Class *************/
var XtrazDebug;

if (top.XtrazDebug) {
	XtrazDebug = top.XtrazDebug;
}
else {
	XtrazDebug = new Object;
	XtrazDebug.inited = false;
	XtrazDebug.debugWindow = null;
	XtrazDebug.displayAlert = false;
	XtrazDebug.gLineBuffer = new Array;
	XtrazDebug.gDebug = false;
	XtrazDebug.windowID = "icqconsole";
	
	XtrazDebug.catchWindowErrors = function(bCatch) {
		if (typeof(bCatch) == "undefined")
			bCatch = true;
		else
			bCatch = ! (! bCatch);
		if (bCatch)
			window.onerror = XtrazDebug.winErrorHandler;
		else
			window.onerror = null;
		return true;
	}
	
	XtrazDebug.setUnique = function(bUnique) {
		if (bUnique)
			XtrazDebug.windowID = "console" + (new Date()).getTime();
		else
			XtrazDebug.windowID = "icqconsole";
	}
	
	XtrazDebug.stop = function() {
		XtrazDebug.gDebug = false;
	}
	
	XtrazDebug.start = function(sURL) {
		XtrazDebug.gDebug = true;
		XtrazDebug.openWindow(sURL);
	}
	
	XtrazDebug.getDebugLevel = function() {
		return XtrazDebug.DebugLevel;
	}
	
	XtrazDebug.setDebugLevel = function(level) {
		if (! isNaN(level))
			XtrazDebug.DebugLevel = level;
	}
	
	XtrazDebug.rawTrace = function(level /* more args */) { // returns ! gDebug, a value suitable for onerror
		if (XtrazDebug.gDebug) {
			var firstArg = 0;
			var logit = true;
			if (typeof(level) == "number") {
				if (XtrazDebug.DebugLevel >= level) {
					firstArg = 1;
				}
				else
					logit = false;
			}
			if (logit) {
				var outstr = XtrazDebug.formatArguments(arguments, firstArg, false);
				XtrazDebug.logString(outstr);
			}
		}
	}
	
	XtrazDebug.logException = function() { // returns ! gDebug, a value suitable for onerror
		if (XtrazDebug.gDebug) {
			var outstr = XtrazDebug.formatArguments(arguments, 0, true);
			XtrazDebug.logString(outstr, 'Exception');
		}
	}
	
	
	XtrazDebug.trace = function(level /* more args */) { // returns ! gDebug, a value suitable for onerror
		if (XtrazDebug.gDebug) {
			var logit = true;
			var firstArg = 0;
			if (typeof(level) == "number") {
				if (XtrazDebug.DebugLevel >= level) {
					firstArg = 1;
				}
				else
					logit = false;
			}
			if (logit) {
				var outstr = XtrazDebug.formatArguments(arguments, firstArg, true);
				XtrazDebug.logString(outstr);
			}
		}
	}
	
	// backward compat
	XtrazDebug.alert = XtrazDebug.trace;
	
	
	XtrazDebug.assert = function (cond) {
	//	if (cond == undefined || cond == null || cond == 0 || cond == false) {
		if (XtrazDebug.gDebug) {
			if ( ! cond) {
				if (cond == undefined)
					cond = 'undefined';
				
				var args = new Array;
				args.push("Assert failed: " + cond);
				for (var i = 1; i < arguments.length; i++) {
					args.push(arguments[i]);
				}
				var str = XtrazDebug.formatArguments(args, 0, false);
				XtrazDebug.logString(str, 'Exception');	
			}
		}
	}
	
	XtrazDebug.clear = function() {
		try {
			XtrazDebug.AlertString = '';
			XtrazDebug.debugWindow.clear();
		}
		catch (er) {
		}
	}
	
	/******** Implementation *********/
	
	XtrazDebug.onConsoleClosed = function() {
		XtrazDebug.debugWindow = null;
	}
	
	// open debug console if needed
	XtrazDebug.init = function() {
		if (XtrazDebug.inited)
			return;
			
		XtrazDebug.inited = true;
		XtrazDebug.AlertTimer = null;
		XtrazDebug.AlertString = '';
		XtrazDebug.DebugLevel = 0;
		XtrazDebug.ParentDied = false;
		
		var href = window.location.pathname;
		var ind = href.lastIndexOf("/");
		if (ind > -1)
			href = href.substring(ind + 1, href.length);
	
		XtrazDebug.prefix = href;
	}
	
	XtrazDebug.openWindow = function(sURL) {
		if (XtrazDebug.debugWindow) {
			try {
				if (XtrazDebug.debugWindow.closed) {
					XtrazDebug.debugWindow = null;
				}
			}
			catch (e){
			}
		}
		if (! XtrazDebug.debugWindow) {
			if (top.XtrazDebug && top.XtrazDebug.debugWindow) {
	//			alert("found top debug window");
				XtrazDebug.debugWindow = top.XtrazDebug.debugWindow;
			}
			else if (window.opener && window.opener.XtrazDebug && window.opener.XtrazDebug.debugWindow) {
				XtrazDebug.debugWindow = window.opener.XtrazDebug.debugWindow;
			}
			else {
				if (sURL == undefined || ! sURL.length)
					sURL = '';
				var str = "top=5,left=0,width=450,height=" + (window.screen.availHeight - 20) + ",scrollbars=no,resizable=yes";
				XtrazDebug.debugWindow = window.open(sURL + "icqdebugconsole.html", XtrazDebug.windowID, str);
		//			alert("openend window" + XtrazDebug.debugWindow);
				if (XtrazDebug.debugWindow) {
					XtrazDebug.debugWindow.focus();
					window.focus();
				}
				else {
					alert("Debug window failed to open; you may have to tinker with your popup block settings");
				}
			}
		}
		else {
	//			myAlert("have opener, not opening console");
		}
	}
	
	XtrazDebug.logString = function(str, sClass) {
		if (typeof(sClass) != 'string')
			sClass = 'Trace';
		var dstr = XtrazDebug.makeTimeStamp();
		XtrazDebug.gLineBuffer[XtrazDebug.gLineBuffer.length] = {type: sClass, data: dstr + str};
		//XtrazDebug.gLineBuffer.push({type: sClass, data: dstr + str} );
		if (! XtrazDebug.gLogTimer) {
			XtrazDebug.gLogTimer = setTimeout("XtrazDebug.dumpLog()", 500);
		}
	}
	
	XtrazDebug.flush = function() {
		if (XtrazDebug.gLogTimer) {
			clearTimeout(XtrazDebug.gLogTimer);
			XtrazDebug.gLogTimer = null;
		}
		XtrazDebug.dumpLog();	
	}
	
	XtrazDebug.makeTimeStamp = function() {
		var d = new Date();
		var ret = "�<B>" + formatnumber(d.getHours()) + ":" + formatnumber(d.getMinutes()) + ":" + formatnumber(d.getSeconds()) + ' ' + XtrazDebug.prefix+"</B>: ";
		return ret;
	}
	
	XtrazDebug.formatArguments = function(args, firstArg, bEncode) {
		var str = '';
		try {
			var last = args.length - 1;
			for (var i = firstArg; i <= last; i++) {
				str += XtrazDebug.objectToString(args[i], bEncode);
				if (i < last)
					str += ' ';
			}
		}
		catch (e) {
			str += "<font color='red'>Exception occured while processing alert</font>";
		}
		return str;
	}
	
	XtrazDebug.dumpLog = function() {
		XtrazDebug.gLogTimer = null;
	//	var logged = false;
		if (XtrazDebug.debugWindow){
			var len = XtrazDebug.gLineBuffer.length;
			var rec;
			for (var i = 0; i < len; i++) {
				try {
					rec = XtrazDebug.gLineBuffer[i];
					XtrazDebug.debugWindow.log(rec.data, rec.type);
	//				logged = true;
				}
				catch (er) {
	//				str = "(failed log) " + str;
				}
			}
		}
		XtrazDebug.gLineBuffer = new Array;
	
	/*	if (! logged && (XtrazDebug.displayAlert)) {
			XtrazDebug.AlertString += (str + '\n');
			if (! XtrazDebug.AlertTimer)
				XtrazDebug.AlertTimer = setTimeout("XtrazDebug.timerAlert()", 3000);
		} */
		
		return false;
	}
	
	XtrazDebug.objectToString = function(obj, bEncode, level) {
		var ret = '';
		if (undefined == level)
			level = 0;
		if (undefined == bEncode)
			bEncode = true;
		else if (level > 6)
			return '';
	
		var t = typeof(obj);
		if (t == 'string') {
			if (bEncode)
				ret = XMLEncoder.encode(obj);
			else
				ret = obj;
		}
		else if (t == 'number' || t == 'boolean')
			ret = String(obj);
		else if (t == 'undefined')
			ret = 'undefined';
		else if (obj == null)
			ret = 'null';
		else {
			var logged = true;
			if (obj instanceof Array) {
				ret = '[ ';
				for (var i = 0; i < obj.length; i++) {
					if (i > 0)
						ret += ',';
					ret += XtrazDebug.objectToString(obj[i], bEncode, level + 1);
				}
				ret += ' ]';
			}
			else if (obj instanceof Date) {
				ret = "(* Date: " + obj.toLocaleString() + " *)"
			}
			else if (obj instanceof Error) {
				ret = XtrazDebug.exceptionToString(obj);
			}
			else {
				logged = false;
				var tostring = false;
				try {
					tostring = obj.toString;
				}
				catch (e) {
					tostring = null;
				}
				if (tostring) {
					var ts = typeof(tostring);
					if (ts == "function") {
						ret = obj.toString();
						logged = ((typeof(ret) == "string") && 
										(ret.toLowerCase().indexOf("[object") != 0));
					}
				}
			}
			if (! logged) {
				if (t == "object") {
					ret = "{ ";
					for (var key in obj) {
						var val = obj[key];
						if (typeof(val) != "function") {
							if (val instanceof Array || val instanceof Object)
								val = XtrazDebug.objectToString(val, bEncode, level + 1);
							ret += '*' + key + ": " + val + " ;\t" 	
						}
					}
					ret += " }";
				}
				else {
					try {
						ret = String(obj);
					}
					catch(e) {
						ret = "*Unknown type*";
					}
				}
			}
		}
		return ret;
	}
	
	XtrazDebug.timerAlert = function() {
		XtrazDebug.AlertTimer = null;
		var alertStr = XtrazDebug.AlertString;
		XtrazDebug.AlertString = '';
		XtrazDebug.displayAlert = window.confirm(alertStr + "\n\nContinue popping alerts?");
	}
	
	XtrazDebug.dummyError = function() {
		return true;
	}
	
	XtrazDebug.winErrorHandler = function(errMsg, errURL,errLineNum) {
		window.onerror = XtrazDebug.dummyError;
		try {
			var ind;
			if (errURL != undefined) {
				ind = errURL.lastIndexOf("/");
				if (ind > 0)
					errURL = errURL.substring(ind + 1, errURL.length);
			}
			var str = XtrazDebug.formatArguments(["Window Error", "<u>message</u>:",
				errMsg, "<u>URL</u>:", errURL, "<u>line</u>", errLineNum], 0, false);
			XtrazDebug.logString(str, 'Error');
		}
		catch (e) {}
		window.onerror = XtrazDebug.winErrorHandler;
		return true;
	}
	
	
	/********* Init XtrazDebug ***********/
	XtrazDebug.init();
	
	
	/********* Utilities ***********/
	
	XtrazDebug.exceptionToString = function(ex, bNoFormat) {
		var format = ! bNoFormat;
		var ret = '';
		if (format)
			ret += '<font color="#009966">';
		else
			ret += '*';
		ret += 'EXCEPTION';
		if (undefined == ex) {
			ret += ' undefined';
		}
		else {
			if (ex.number != undefined)
				ret += (' <B>number</B> ' + ex.number);
			if (ex.description != undefined) {
				ret += (' <B>description</B>:' + ex.description);
			}
			else if (ex.message != undefined)
				ret += (' <B>message</B> ' + ex.message);
		}
		if (format)
			ret += "</font> ";
		else
			ret += '*';
		return ret;
	}
	
	
	// Utilities
	function formatnumber(n) {
		var ret = String(n);
		if (ret.length == 1)
			ret = "0" + ret;
		return ret;
	}
	
	/********* Standalone impl. of XMLEncoder *********/
	
	if (typeof(XMLEncoder) != "object") {
		XMLEncoder = new Object;
		XMLEncoder.symbolstring = '';
		XMLEncoder._entities = new Array (
				{ str:"\&amp;", regEncode: /\&/g, regDecode: /\&amp;/g,   symbol:'&', len: 5 }, // must be first
				{ str: "\&lt;",   regEncode: /</g, regDecode: /\&lt;/g, symbol:'<', len:4 }, 
				{ str:"\&gt;",   regEncode: />/g, regDecode: /\&gt;/g, symbol:'>', len:4 }, 
				{ str:"\&quot;",  regEncode: /\"/g, regDecode: /\&quot;/g, symbol:'"', len: 6 }
			);
		
		
		XMLEncoder.encode = function(str) {
			var ret = str;
			var sym, len = XMLEncoder._entities.length;
			for (var i = 0; i < len; i++) {
				sym = XMLEncoder._entities[i];
				if (ret.indexOf(sym.symbol) >= 0)
					ret = ret.replace(sym.regEncode, sym.str);
			}
			
			return ret;
		}
		
		// decode:
		// in: string
		// out: string
		XMLEncoder.decode = function(str) {
			var ret = str;
			var sym, len = XMLEncoder._entities.length;
			for (var i = 0; i < len; i++) {
				sym = XMLEncoder._entities[i];
				if (ret.indexOf(sym.str) >= 0)
					ret = ret.replace(sym.regDecode, sym.symbol);
			}
			
			return ret;
		}
	}
//============== End class implementation ==============//

}