/******************************************
// XtrazRandom
// ** Interface **
// init
// findUsers ( group )
// getRandomUIN ()
//
// ** Dependencies **
// XtrazDebug
// XtrazUtils
// XtrazBroadcaster
*******************************************/

var XtrazRandom;

if (top.XtrazRandom) {
	XtrazRandom = top.XtrazRandom;
}
else {
	XtrazRandom = new Object;
	XtrazRandom.host = 'http://www.icq.com';
	XtrazRandom.findURL = '';
	XtrazRandom.registerURL = '';
	XtrazRandom.bInited = false;
	XtrazRandom.uinList = new Array;
	XtrazRandom.lastGroupID = 0;
	XtrazRandom.usedUINs = {}
	XtrazRandom.msgServerReady = 'rndReady';
	XtrazRandom.bRegistered = 0;
	XtrazRandom.manualMode = false;
	
	var lastGroup = ""
	var uin_to_invite = ""
	/*var gl_on_invitation = false;
	var gl_waiting_invitations = new Array(); 
	var tryCount = 0
	var gl_from_uin;*/
	var maxRetry = 1;
	var randomUIN = new Array();
	
	XtrazRandom.init = function() {
		if (! XtrazRandom.bInited) {
			XtrazRandom.bInited = true;
			XtrazRandom.host = XtrazPreferences.getPreference("Random", "HostURL");
			XtrazRandom.findURL = XtrazPreferences.getPreference("Random", "FindURL");
			XtrazRandom.registerURL = XtrazPreferences.getPreference("Random", "RegisterURL");
			XtrazRandom.manualMode = XtrazPreferences.getPreference("Random", "Manual");
		}
	}
		
	XtrazRandom.unregisterUser = function (uin)
	{
		this.init();
		var xml_doc = XMLUtils.getScratchDocument();
		var url = XtrazUtils.sprintf(XtrazRandom.registerURL, 0, uin);
		XtrazDebug.alert("unregisterUser", url)
		xml_doc.load(XtrazRandom.host + url);
	}
	
	XtrazRandom.findUsers = function (game_group) {
		this.init();
	
		var bReport;
		if (! game_group) { // function called with default params, to reload
			bReport = false;
			XtrazDebug.assert(XtrazRandom.lastGroupID, "XtrazRandom.findUsers called with no default params");
			game_group = XtrazRandom.lastGroupID;
		}
		else {
			bReport = true;
			XtrazRandom.lastGroupID = game_group;
		}
	
	// http://genesis1/random/find_multi_users.php?group=505&uin=50500&nbusers=20
		var url = XtrazUtils.sprintf(XtrazRandom.findURL, game_group, XtrazConnector.Owner.ScreenName);
		XtrazDebug.trace("find_user:", url)
		XMLUtils.loadDocumentAsync(XtrazRandom.host + url, this, "onUsersLoaded", {group: game_group, report: bReport });
	}
	
	XtrazRandom.onUsersLoaded = function(xml_doc, params) {
	// http://genesis1/random/find_multi_users.php?group=505&uin=50500&nbusers=20
		var status = XMLUtils.getParseError(xml_doc);
		XtrazRandom.uinList = [];
		if (status != 0 ) {
			XtrazDebug.trace("parseerror", status, xml_doc.parseError.reason, xml_doc.xml);
		}
		else {
			XtrazDebug.trace("findUsers received", xml_doc.xml);
			var uinNodes = xml_doc.selectNodes("//UIN");
			if (uinNodes) {
				var ownerUIN = XtrazConnector.Owner.ScreenName;
				for (var i = 0; i < uinNodes.length; i++) {
					var tmp = XMLUtils.getNodeValue(uinNodes[i]);
					if (tmp == ownerUIN) {
						XtrazDebug.trace("random: ignoring owner uin", ownerUIN);
					}
					else if (! XtrazRandom.usedUINs[tmp]) {
						XtrazRandom.uinList.push(tmp);
					}
					else {
						XtrazDebug.trace("random findusers: uin", tmp, "repeated, ignoring");
					}
				}
			}
		}
		if (params.report) {
			XtrazBroadcaster.broadcast(XtrazRandom.msgServerReady, params.group, XtrazRandom.uinList.length);
		}
	}
	
	XtrazRandom.registerSelf = function(groupID) {
		this.init();
		if (this.bRegistered) {
			XtrazDebug.trace("random register called while registered");
		}
		else {
			this.bRegistered = true;
			if (! groupID) { // function called with default params, to reload
				groupID = XtrazRandom.lastGroupID;
			}
		
			var qXml = "<Q><PluginID>random_service</PluginID></Q>";
			var dataXml = "<MSG><srv><id>cRandomizerSrv</id></srv><C>Register</C><CHATGROUP>" + groupID + "</CHATGROUP></MSG>";
			// Send notification to the local Randomizer service (to register)
			XtrazDebug.trace("XtrazRandom.registerSelf", dataXml);
			XtrazConnector.getICQConnector().NotifyPlugin( qXml, dataXml);
			if (this.manualMode) {
				var xml_doc = XMLUtils.makeDocument(true);
				var url = XtrazUtils.sprintf(XtrazRandom.registerURL, groupID, XtrazConnector.Owner.ScreenName);
				XtrazDebug.trace("registerUser", url)
				xml_doc.load(XtrazRandom.host + url);
			}
		}
	}
	
	XtrazRandom.unregisterSelf = function() {
		this.init();
		if (! this.bRegistered) {
			XtrazDebug.trace("random unregister called while not registered");
		}
		else {
			this.bRegistered = false;
			XtrazDebug.trace("XtrazRandom.unregisterSelf");
			qXml = "<Q><PluginID>random_service</PluginID></Q>";
			dataXml = "<MSG><srv><id>cRandomizerSrv</id></srv><C>Unregister</C></MSG>";
			XtrazDebug.trace("XtrazRandom.unregisterSelf", dataXml);
			// Send notification to the local Randomizer service to unregister
			XtrazConnector.getIcqConnector().NotifyPlugin( qXml, dataXml);
			if (this.manualMode)
				this.unregisterUser(XtrazConnector.Owner.ScreenName);
		}
	}
		
	XtrazRandom.getRandomUIN = function() {
		var ret = 0;
		if (XtrazRandom.uinList.length) {
			ret = XtrazRandom.uinList.pop();
			XtrazRandom.usedUINs[ret] = 1;
			if (! XtrazRandom.uinList.length) {
				XtrazRandom.findUsers(); // repeat search silently
			}
		}
		return ret;
	}
}